
import bpy
import sys
import os
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATH= argv[0]
TYPES=argv[1].split(":--separator--:")
NAMES=argv[2].split(":--separator--:")
REMOVE_BLEND=eval(argv[3])
REMOVE_DATA=eval(argv[4])
REMOVE_LINKED_DATA=eval(argv[5])
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
# print(TYPES,NAMES)
def get_all_nodes_from_material(node_tree):
    groups=[]
    groups.extend(node_tree.nodes[:])
    for node in node_tree.nodes:
        if node.type=='GROUP':
            groups.extend(get_all_nodes_from_material(node.node_tree))
    return groups
def get_images_from_material(mat):
    images=[]
    if mat.use_nodes:
        for i in get_all_nodes_from_material(mat.node_tree):
            if i.type=='TEX_IMAGE' or i.type=='TEX_ENVIRONMENT':
                if i.image:
                    images.append(i.image)
    return images
def clear_assets(FILEPATH, TYPES, NAMES):
    
    for i,a in enumerate(TYPES):
        try:
            print("Clearing...",NAMES[i])
            if a=='COLLECTION':
                bpy.data.collections.get(NAMES[i]).asset_clear()
                if REMOVE_LINKED_DATA:
                    objects=bpy.data.collections.get(NAMES[i]).all_objects[:]
                    for object in objects:

                        try:
                            for mat in object.data.materials:
                                if mat:
                                    if (mat.use_fake_user and mat.users<=2) or (not mat.use_fake_user and mat.users<=1):
                                        for image in get_images_from_material(mat):
                                            if (image.use_fake_user and image.users<=2) or (not image.use_fake_user and image.users<=1):
                                                bpy.data.images.remove(image)
                                        bpy.data.materials.remove(mat)
                            bpy.data.objects.remove(object)
                        except Exception as e:
                            print(e)
                        
                if REMOVE_DATA:
                    bpy.data.collections.remove(bpy.data.collections.get(NAMES[i]))
            elif a=='OBJECT':
                
                bpy.data.objects.get(NAMES[i]).asset_clear()
                
                if REMOVE_LINKED_DATA:
                    materials=bpy.data.objects.get(NAMES[i]).data.materials[:]
                    for mat in materials:
                        if (mat.use_fake_user and mat.users<=2) or (not mat.use_fake_user and mat.users<=1):
                            for image in get_images_from_material(mat):
                                if (image.use_fake_user and image.users<=2) or (not image.use_fake_user and image.users<=1):
                                    bpy.data.images.remove(image)
                            bpy.data.materials.remove(mat)
                if REMOVE_DATA:
                    bpy.data.objects.remove(bpy.data.objects.get(NAMES[i]))
            elif a=='MATERIAL':
                bpy.data.materials.get(NAMES[i]).asset_clear()
                if REMOVE_LINKED_DATA:
                    for image in get_images_from_material(bpy.data.materials.get(NAMES[i])):
                        if (image.use_fake_user and image.users<=2) or (not image.use_fake_user and image.users<=1):
                            bpy.data.images.remove(image)
                if REMOVE_DATA:
                    bpy.data.materials.remove(bpy.data.materials.get(NAMES[i]))
                    
            elif a=='WORLD':
                bpy.data.worlds.get(NAMES[i]).asset_clear()
                if REMOVE_LINKED_DATA:
                    for image in get_images_from_material(bpy.data.worlds.get(NAMES[i])):

                        if (image.use_fake_user and image.users<=2) or (not image.use_fake_user and image.users<=1):
                            bpy.data.images.remove(image)
                if REMOVE_DATA:
                    bpy.data.worlds.remove(bpy.data.worlds.get(NAMES[i]))
            elif a=='NODETREE':
                bpy.data.node_groups.get(NAMES[i]).asset_clear()
                if REMOVE_DATA:
                    bpy.data.node_groups.remove(bpy.data.node_groups.get(NAMES[i]))
            print("Cleared ",NAMES[i])
        except Exception as e:
            print("An Error Occured!",e)
    
    #bpyprint(dir(bpy.data))
    asset_data_exists = other_assets_exist()
    bpy.ops.wm.save_mainfile()
    

    bk = FILEPATH + "1"
    if os.path.exists(bk):
        os.remove(bk)
    if REMOVE_BLEND and not asset_data_exists:
        if os.path.exists(FILEPATH):
            os.remove(FILEPATH)

def other_assets_exist():
    data_types=['objects','materials','node_groups','worlds','actions', 'armatures', 'brushes', 'cameras', 'collections', 'curves', 'grease_pencils', 'images', 'lattices', 'lightprobes', 'lights', 'meshes', 'metaballs', 'movieclips','particles', 'pointclouds', 'sounds', 'speakers', 'texts', 'textures', 'volumes']
    for d in data_types:
        for a in getattr(bpy.data,d,[]):
            if a.asset_data:
                return True
    return False

    #bpy.ops.wm.quit_blender()

clear_assets(FILEPATH, TYPES, NAMES)
