from cmath import e
from tokenize import group
import bpy
import sys
import os
import time
import functools
import mathutils
import random
import uuid
import re
def get_path_from_config(name):
    config_dir=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))))
    result=None
    with open(os.path.join(config_dir, "config", "TA-Config.txt"), mode='r', newline='\n', encoding='utf-8') as file:
        for p in file.readlines():
            if name in p:
                result = p[p.index("===")+3:]
                result = str(result.replace("\n", ""))
    return result
def get_value_from_config(name):
    config_dir=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))))
    result=None
    with open(os.path.join(config_dir, "config", "TA-Config.txt"), mode='r', newline='\n', encoding='utf-8') as file:
        for p in file.readlines():
            if name in p:
                result = p[p.index("===")+3:]
                result = str(result.replace("\n", ""))
    return eval(result)
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATHS= argv[0].split(":-path-:")
OBJECTS_PATH=get_path_from_config("objects_directory")
MATS_PATH=get_path_from_config("materials_directory")
WORLDS_PATH=get_path_from_config("worlds_directory")
NODEGROUPS_PATH=get_path_from_config("node_groups_directory")
FILTERS=['OBJECTS','MATS','WORLDS','NODEGROUPS','MESH']
OVERRIDE=False
MIN_NODES=0
SHADING='Cycles'
ENGINE='CYCLES'
MAX_TIME=3600
FORCE_PREVIEWS=False
CLEAR_MATERIALS='True'
CAMERA_ANGLE='XY'
KITBASH_ASSETS=False
APPLY_ROTATION=False
CLEAR_PARENT=False
CATALOG='Filename'
ADD_PLANE=True
WORLD_STRENGTH=5
JOIN_CHILDREN=False
FILEPATH=FILEPATHS.pop(0)
WHAT_TO_SAVE='Everything'
PACK=True
CHANGE_DISPLACEMENT_TYPE=False
REMOVE_SUBDIV=False
ORIGIN_TO_BOTTOM=False
SAVE_AS_SINGLE_BLEND_FILE=True
BLENDS_PATH=get_path_from_config("blends_directory")
INDIVIDUAL_FILES=True
supports_thumbnails=['MESH','LIGHT']
context = bpy.context
scene = context.scene
st=time.time()
bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
bpy.context.preferences.system.texture_collection_rate=5
bpy.context.preferences.system.texture_time_out=5
random_id_source = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
def decode_catalog_name(catalog):
    if catalog=='Filename':
        return os.path.splitext(os.path.basename(FILEPATH))[0]
    elif catalog=='Directory':
        return os.path.basename(os.path.dirname(FILEPATH))
    else:return catalog
def get_id(length=6):
    return "".join(random.sample(random_id_source, length))
def find_scene_from_object(object):
    for s in bpy.data.scenes:
        if object in s.objects[:]:
            return s
    return None
def set_new_origin_of_object(obj):
    corners=[(mathutils.Vector(b)) for b in obj.bound_box]
    min_z=min(((mathutils.Vector(b)).z for b in corners))
    max_z=max(((mathutils.Vector(b)).z for b in corners))
    min_x=min(((mathutils.Vector(b)).x for b in corners))
    max_x=max(((mathutils.Vector(b)).x for b in corners))
    min_y=min(((mathutils.Vector(b)).y for b in corners))
    max_y=max(((mathutils.Vector(b)).y for b in corners))
    origin= mathutils.Vector(((min_x+max_x)/2,(min_y+max_y)/2,min_z))
    to_move=(obj.matrix_world.inverted() @obj.location)-origin
    obj.data.transform(mathutils.Matrix.Translation(to_move))
    _, rot, sca = obj.matrix_world.decompose()
    matrix_without_location = mathutils.Matrix.LocRotScale([0,0,0], rot, sca)
    obj.location-=matrix_without_location @to_move
def join_meshes_with_same_parent(scene):
    
    object_sets={}
    for o in scene.objects:
        if o.type=='EMPTY':
            o.location=[0,0,0]
            object_sets[o.name]=[a for a in o.children if a.type=='MESH']
            o.name=o.name+"_parent"
    for parent,objects in object_sets.items():
        #print(parent,objects)
        if objects:
            override=context.copy()
            for area in context.window_manager.windows[0].screen.areas:
                area.type='VIEW_3D'
                #override['scene']=scene
                override['area']=area
                override['space_data']=area.spaces[0]
                override['screen']=context.window_manager.windows[0].screen
                override['window']=context.window_manager.windows[0]
                override['selected_objects']=objects
                override['object']=objects[0]
                override['active_object']=objects[0]
                override['selected_editable_objects']=objects
                view_area=area
                break
            objects[0].name=parent
            try:
                with context.temp_override(**override):
                    bpy.ops.object.make_single_user(type='ALL', object=True, obdata=True, material=False, animation=False, obdata_animation=False)
            except:
                print("Could not make single user!")
            # for obj in objects:
            #     print(obj)
            #bpy.ops.object.convert(override,target='MESH', keep_original=False)

            if APPLY_ROTATION:
                
                with context.temp_override(**override):
                    bpy.ops.object.transform_apply(location=False, rotation=True, scale=False,isolate_users=True)
            if CLEAR_PARENT:
                with context.temp_override(**override):
                    bpy.ops.object.parent_clear(type='CLEAR_KEEP_TRANSFORM')
            if JOIN_CHILDREN:
                if len(objects)>1:
                    with context.temp_override(**override):
    
                        bpy.ops.object.join()
            else:
                #print("Moving..",objects,parent)
                with context.temp_override(**override):
                    bpy.ops.object.move_to_collection(collection_index=0, is_new=True, new_collection_name=parent)
    if CHANGE_DISPLACEMENT_TYPE:
        for m in bpy.data.materials:
            m.cycles.displacement_method='BUMP'
    if REMOVE_SUBDIV:
        for obj in bpy.data.objects:
            for m in obj.modifiers:
                if m.type=='SUBSURF':
                    try:
                        obj.modifiers.remove(m)
                    except Exception as e:
                        print("Could not remove Subdiv modifier!",e)
def get_random_uuid():
    return str(uuid.uuid4())
def get_name_to_display(name):
    if "/" in name:
        #substr=name[name.rindex("/")+1:]
        return name[name.rindex("/")+1:] +f" ({name[:name.rindex('/')]})"
    else:
        return name
def get_catalog_by_name(path,name):
    if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='r',newline="\n",encoding="UTF-8") as catalog_file:
            for l in catalog_file.readlines():
                if not l.startswith("#") and not l.startswith("VERSION") and ":" in l:
                    if l[l.index(":")+1:l.rindex(":")]==name:
                        return l[:l.index(":")]
    return None
def create_new_catalog(path,name):
    uuids=[]
    #uuid=get_random_uuid()
    result = [_.start() for _ in re.finditer("/",name )] +[len(name),]
    for a in range(len(result)):
        uuids.append(get_random_uuid())
    if not os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='w+',newline="\n",encoding="UTF-8") as catalog_file:
            catalog_file.writelines(["\nVERSION 1",])
            for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    else:
        
        if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
            with open(os.path.join(path,"blender_assets.cats.txt"), mode='a',newline="\n",encoding="UTF-8") as catalog_file:
                for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    
    return get_catalog_by_name(path,name) if get_catalog_by_name(path,name) else "00000000-0000-0000-0000-000000000000"
def delete_object_with_data(obj):
    if obj and obj.name in bpy.data.objects:
        data = obj.data
        isMesh = obj.type == 'MESH'
        bpy.data.objects.remove(obj, do_unlink=True)
        if isMesh:
            bpy.data.meshes.remove(data)
def get_bounding_box_of_collection(col):
    corners=[]
    for ob in col.all_objects:
        corners.extend([(ob.matrix_world @ mathutils.Vector(b)) for b in ob.bound_box])
    min_z=min(((mathutils.Vector(b)).z for b in corners))
    max_z=max(((mathutils.Vector(b)).z for b in corners))
    min_x=min(((mathutils.Vector(b)).x for b in corners))
    max_x=max(((mathutils.Vector(b)).x for b in corners))
    min_y=min(((mathutils.Vector(b)).y for b in corners))
    max_y=max(((mathutils.Vector(b)).y for b in corners))
    return mathutils.Vector((min_x,min_y,min_z)),mathutils.Vector((max_x,max_y,max_z))
def get_collections_from_scene(scene):
    return [c for c in bpy.data.collections if scene.user_of_id(c)]
def get_biggest_object_from(col):
    if col.all_objects:

        max_volume_object=col.all_objects[0]
        for object in col.all_objects:
            if object.dimensions.x*object.dimensions.y*object.dimensions.z>max_volume_object.dimensions.x*max_volume_object.dimensions.y*max_volume_object.dimensions.z:
                max_volume_object=object
        return object
    return None
def capture_thumbnail_for_collection(context,col,path, shading="Material",angle='X',add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene=context.scene  
    scene.render.image_settings.file_format = 'PNG'
    if col not in get_collections_from_scene(scene):
        scene.collection.children.link(col)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(col.name+"_"+get_id(8))+'.png')
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_data.clip_start=0
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    bottom_left,top_right=get_bounding_box_of_collection(col)
    local_bbox_center =(bottom_left+top_right)/2
    location_backup=[]
    for ob in col.all_objects:
        location_backup.append((ob,ob.location.copy()))
        # No longer needed as we are setting location before marking asset
        # ob.location=ob.location-mathutils.Vector((local_bbox_center.x,local_bbox_center.y,0))

    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        scene.collection.objects.link(ground_plane)
        min_z=bottom_left.z
        ground_plane.location=(local_bbox_center.x, local_bbox_center.y,min_z)
    global_bbox_center = local_bbox_center
    track_object.location=(0,0,global_bbox_center.z)
    dist=max([abs(top_right.x-bottom_left.x),abs(top_right.y-bottom_left.y),abs(top_right.z-bottom_left.z)])*2
    object=get_biggest_object_from(col)
    if object:
        object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
        camera_object.location=object_matrix@mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    else:
        camera_object.location=mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))    
    
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    #override = context.copy()
    #override["object"] = camera_object
    with context.temp_override(object=camera_object):

        bpy.ops.constraint.apply(constraint=constraint.name)
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    for area in context.window_manager.windows[0].screen.areas:
            area.type='VIEW_3D'
            #override['scene']=scene
            override['area']=area
            override['space_data']=area.spaces[0]
            override['screen']=context.window_manager.windows[0].screen
            override['window']=context.window_manager.windows[0]
            area.spaces[0].region_3d.view_perspective = 'CAMERA'
            override['active']=col.all_objects[0] if col.all_objects else None
            if col.all_objects:
                override['selected_objects']=[col.all_objects[0],]
            view_area=area
            break
                
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    context.scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=context.scene.world.node_tree.nodes.get("Mapping")
    context.scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]          
    if shading=='Material':
        
        view_area.spaces[0].shading.type = 'MATERIAL'
        view_area.spaces[0].overlay.show_overlays = False
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        # unselected=[a for a in scene.objects if col not in a.users_collection]
        # unselected=[a for a in get_collections_from_scene(scene) if a !=col and a not in col.children_recursive]
        # unselected = [a for a in get_collections_from_scene(scene) if a !=col]
        for obj in unselected:
            if obj.hide_viewport == False:
                obj.hide_viewport = True
                hidden.append(obj)
        with context.temp_override(**override):
            bpy.ops.render.opengl(write_still=True)
        for obj in hidden:
            obj.hide_viewport = False
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
        
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    if ground_plane:
        delete_object_with_data(ground_plane)
    scene.camera = cameraBackUp
    return render_path
def capture_thumbnail(context,object,path, shading="Material",angle='X',add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene=context.scene  
    scene.render.image_settings.file_format = 'PNG'
    if object not in scene.objects[:]:
        scene.collection.objects.link(object)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(object.name+"_"+get_id(8))+'.png')
    
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_data.clip_start=0
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    local_bbox_center = 0.125 * sum((mathutils.Vector(b) for b in object.bound_box), mathutils.Vector())
    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        scene.collection.objects.link(ground_plane)
        min_z=min(((object.matrix_world @ mathutils.Vector(b)).z for b in object.bound_box))
        ground_plane.location=(object.location.x, object.location.y,min_z)
    global_bbox_center = object.matrix_world @ local_bbox_center
    track_object.location=global_bbox_center
    dist=max(object.dimensions[:])*2
    object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
    camera_object.location=object_matrix@mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    
    
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    #override = context.copy()
    #override["object"] = camera_object
    with context.temp_override(object=camera_object):
        bpy.ops.constraint.apply(constraint=constraint.name)
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    for area in context.window_manager.windows[0].screen.areas:
            area.type='VIEW_3D'
            #override['scene']=scene
            override['area']=area
            override['space_data']=area.spaces[0]
            override['screen']=context.window_manager.windows[0].screen
            override['window']=context.window_manager.windows[0]
            area.spaces[0].region_3d.view_perspective = 'CAMERA'
            override['active']=object
            override['selected_objects']=[object,]
            view_area=area
            break
                
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    context.scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=context.scene.world.node_tree.nodes.get("Mapping")
    context.scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]          
    if shading=='Material':
        
        view_area.spaces[0].shading.type = 'MATERIAL'
        view_area.spaces[0].overlay.show_overlays = False
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.hide_get() == False:
                obj.hide_set(True)
                hidden.append(obj)
        og_hide_render=object.hide_render
        object.hide_render=False
        bpy.ops.render.render(write_still=True)
        object.hide_render=og_hide_render
        for obj in hidden:
            obj.hide_set(False)
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        og_hide_render=object.hide_render
        object.hide_render=False
        bpy.ops.render.render(write_still=True)
        object.hide_render=og_hide_render
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        og_hide_render=object.hide_render
        object.hide_render=False
        bpy.ops.render.render(write_still=True)
        object.hide_render=og_hide_render
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
        
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    if ground_plane:
        delete_object_with_data(ground_plane)
    scene.camera = cameraBackUp
    return render_path
def create_thumbnail(context, ob,shading='Solid'):
    if not os.path.isdir(os.path.join(OBJECTS_PATH,'Thumbnails')):
        os.mkdir(os.path.join(OBJECTS_PATH,'Thumbnails'))
    if shading!='Solid':
        if isinstance(ob,bpy.types.Collection):
            path=capture_thumbnail_for_collection(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
        else:
            path=capture_thumbnail(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
        
        if os.path.isfile(path):
            print("Assigning Thumbnail..")
            with context.temp_override(id=ob):
                bpy.ops.ed.lib_id_load_custom_preview( filepath=path)
    else:
        ob.asset_generate_preview()
def check_if_volumetric(mat):
    if mat.use_nodes:
        output_nodes=[node for node in mat.node_tree.nodes if node.bl_idname=='ShaderNodeOutputMaterial']
        for node in output_nodes:
            if node.inputs[1].is_linked:
                return True
def create_preview(type,objects,objects_to_check_previews):
    global FILEPATH,FILEPATHS,st
    if time.time()-st>MAX_TIME:
        write_to_blend(type, objects)
        if FILEPATHS:
            FILEPATH=FILEPATHS.pop(0)
            bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
            bpy.context.preferences.system.texture_collection_rate=5
            bpy.context.preferences.system.texture_time_out=5
            st=time.time()
            bpy.ops.file.make_paths_absolute()
            if KITBASH_ASSETS:
                for scene in bpy.data.scenes:
                    join_meshes_with_same_parent(scene)
            if PACK:
                try:
                    bpy.ops.file.pack_all()
                except Exception as e:
                    print(e)
            Create_Collection_Assets()
        else:
            bpy.ops.wm.quit_blender()
        return None
    obs=objects_to_check_previews[:]
    if type in FILTERS:
        obs=objects_to_check_previews[:]
        while obs:
            ob=obs[0]
            if not ob.preview or any(ob.preview.image_pixels[:]) or ((type=='COLLECTIONS' or type=='OBJECTS') and SHADING!="Solid") or (type=='MATS' and check_if_volumetric(ob)):
                
                obs.pop(0)
            else:
                return 1
        
        if not SAVE_AS_SINGLE_BLEND_FILE and type!='COLLECTIONS':
            write_to_blend(type, objects)
    if type=="COLLECTIONS":
        Create_Mesh_Assets(objects)
    elif type=="OBJECTS":
        Create_Material_Assets()
    elif type=="MATS":
        Create_World_Assets()
    elif type=="WORLDS":
        Create_NodeGroup_Assets()
    else:
        if SAVE_AS_SINGLE_BLEND_FILE:
            bpy.ops.wm.save_as_mainfile(filepath=os.path.join(BLENDS_PATH,os.path.basename(FILEPATH)))
        if FILEPATHS:
            FILEPATH=FILEPATHS.pop(0)
            bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
            bpy.context.preferences.system.texture_collection_rate=5
            bpy.context.preferences.system.texture_time_out=5
            st=time.time()
            bpy.ops.file.make_paths_absolute()
            if KITBASH_ASSETS:
                for scene in bpy.data.scenes:
                    join_meshes_with_same_parent(scene)
            if PACK:
                try:
                    bpy.ops.file.pack_all()
                except Exception as e:
                    print(e)
            Create_Collection_Assets()
        else:
            bpy.ops.wm.quit_blender()
    return None
def get_available_name(path,name):
    name=name.replace(".blend","")
    new_name=name
    if os.path.isdir(path):
        files = [file for file in os.listdir(path)]
        final_name = name
        i = 1
        while (final_name+".blend" in files):
            final_name = name+f"_{i}"
            i = i+1
        new_name = final_name
    return new_name+".blend"
def write_to_blend(type, objects):
    blend_name=os.path.basename(FILEPATH)
    if objects:
        if type=="OBJECTS" or type=="COLLECTIONS":
            if OVERRIDE=='COPY':
                blend_name=get_available_name(OBJECTS_PATH,blend_name)
            path=os.path.join(OBJECTS_PATH,blend_name)
                
        elif type=="MATS":
            if OVERRIDE=='COPY':
                blend_name=get_available_name(MATS_PATH,blend_name)
            path=os.path.join(MATS_PATH,blend_name)
        elif type=="WORLDS":
            if OVERRIDE=='COPY':
                blend_name=get_available_name(WORLDS_PATH,blend_name)
            path=os.path.join(WORLDS_PATH,blend_name)    
        else:
            if OVERRIDE=='COPY':
                blend_name=get_available_name(NODEGROUPS_PATH,blend_name)
            path=os.path.join(NODEGROUPS_PATH,blend_name)
        
        
    


inputs_to_skip_compare=[9,]
default_values_bsdf=[[0.8, 0.8, 0.8, 1.0], 0.0, [1.0, 0.2, 0.1], [0.8, 0.8, 0.8, 1.0], 1.4, 0.0, 0.0, 0.5, 0.0, 0.4, 0.0, 0.0, 0.0, 0.5, 0.0, 0.03, 1.45, 0.0, 0.0, [0.0, 0.0, 0.0, 1.0], 1.0, 1.0, [0.0, 0.0, 0.0], [0.0, 0.0, 0.0],0]

def get_value(a):
    try:
        value=[round(b,2) for b in a]
    except:
        value=round(a,2)
    return value
def check_if_default(mat):
    if set([m.type for m in mat.node_tree.nodes if not m.mute]).difference(set(["BSDF_PRINCIPLED","OUTPUT_MATERIAL"])):
        return False
    else:
        bsdf=[m for m in mat.node_tree.nodes if not m.mute and m.type=='BSDF_PRINCIPLED']
        if bsdf:
            bsdf=bsdf[0]
            for i in range(len(bsdf.inputs)-3):
                if i not in inputs_to_skip_compare and get_value(bsdf.inputs[i].default_value)!=default_values_bsdf[i]:
                    return False
                
            return True
def does_support_thumbnails(ob):
    return isinstance(ob,bpy.types.Material) or isinstance(ob,bpy.types.World) or  (isinstance(ob,bpy.types.Object) and ob.type in supports_thumbnails and not (isinstance(ob,bpy.types.Object) and ob.type=='MESH' and len(ob.evaluated_get(bpy.context.evaluated_depsgraph_get()).data.polygons)<1)) or (isinstance(ob,bpy.types.NodeTree) and [a for a in ob.interface.items_tree if a.in_out=='OUTPUT']) or SHADING!='Solid'
def get_all_nodegroups_from_material(node_tree):
    groups=[]
    if node_tree:
        for node in node_tree.nodes:
            if node.type=='GROUP':
                if node.node_tree:
                    groups.append(node.node_tree)
                    groups.extend(get_all_nodegroups_from_material(node.node_tree))
    return groups
def Create_Collection_Assets():
    objects=[]
    objects_to_check_previews=[]
    data_used=[]
    if "COLLECTIONS" in FILTERS and (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(OBJECTS_PATH,os.path.basename(FILEPATH)))):
        for scene in bpy.data.scenes:
            for col in [c for c in bpy.data.collections if scene.user_of_id(c)]:
                
                if col.all_objects:
                    bottom_left,top_right=get_bounding_box_of_collection(col)
                    bbox_center=(bottom_left+top_right)/2
                    location_backup=[]
                    for obj in col.all_objects:
                        location_backup.append((obj,obj.location.copy()))
                        obj.location=obj.location-mathutils.Vector((bbox_center.x,bbox_center.y,0))
                    if not col.hide_viewport and col not in data_used and [a for a in col.all_objects if a.type!='EMPTY' ] and (WHAT_TO_SAVE=='Everything' or (WHAT_TO_SAVE=='Non-Asset' and not col.asset_data) or (WHAT_TO_SAVE=='Marked Assets' and col.asset_data)):
                        
                        data_used.append(col)
                        
                        col.asset_mark()
                        col.asset_data.tags.new(col.name)
                        if CATALOG!='NONE':
                            col.asset_data.catalog_id=create_new_catalog(OBJECTS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Objects/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
                        objects.append(col)
                        if [a for a in col.all_objects if a.type!='EMPTY' and a.type!='LIGHT' and a.display_type!='WIRE'and a.display_type!='BOUNDS' and a.hide_render==False]:
                            objects_to_check_previews.append(col)
                        if not (col.preview and any(col.preview.image_pixels[:])) or FORCE_PREVIEWS:
                            create_thumbnail(context,col,SHADING)
                        
                        #ob.asset_generate_preview()
    
    bpy.app.timers.register(functools.partial(
    create_preview, "COLLECTIONS",objects,objects_to_check_previews), first_interval=0)
def Create_Mesh_Assets(collection_objects=[]):
    objects=[]
    objects_to_check_previews=[]
    data_used=[]
    if "OBJECTS" in FILTERS and (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(OBJECTS_PATH,os.path.basename(FILEPATH)))):
        for scene in bpy.data.scenes:
            for ob in scene.objects:
                if ob.users>0 and ob.type in FILTERS and not ob.hide_get() and not ob.hide_viewport and ob.data not in data_used and (WHAT_TO_SAVE=='Everything' or (WHAT_TO_SAVE=='Non-Asset' and not ob.asset_data) or (WHAT_TO_SAVE=='Marked Assets' and ob.asset_data)):
                    data_used.append(ob.data)
                    if ob.type=='MESH' and (ob.display_type == 'WIRE' or ob.display_type == 'BOUNDS' ):
                        continue    
                    if ob.type in {'MESH','CURVE','SURFACE','TEXT','META'}:
                        ob.display_type='TEXTURED'
                        if CLEAR_MATERIALS:
                            for mat in ob.data.materials:
                                if mat:
                                    if mat.use_nodes:
                                        for n in get_all_nodegroups_from_material(mat.node_tree):
                                                n.asset_clear()
                                    mat.asset_clear()
                    if ORIGIN_TO_BOTTOM:
                        set_new_origin_of_object(ob)
                    ob.asset_mark()
                    ob.asset_data.tags.new(ob.name)
                    ob.asset_data.tags.new(ob.type.title())
                    if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(OBJECTS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Objects/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
                    objects.append(ob)
                    if does_support_thumbnails(ob):
                        objects_to_check_previews.append(ob)
                        if not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS:
                            create_thumbnail(context,ob,SHADING)
                    
                    #ob.asset_generate_preview()
    
    bpy.app.timers.register(functools.partial(
    create_preview, "OBJECTS",objects+collection_objects,objects_to_check_previews), first_interval=0)
def Create_Material_Assets():
    mats=[]
    if "MATS" in FILTERS and (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(MATS_PATH,os.path.basename(FILEPATH)))):
        for ob in bpy.data.materials:
            if ob.name!='Dots Stroke' and ob.users>0  and (WHAT_TO_SAVE=='Everything' or (WHAT_TO_SAVE=='Non-Asset' and not ob.asset_data) or (WHAT_TO_SAVE=='Marked Assets' and ob.asset_data)):
                if ob.use_nodes:
                    if check_if_default(ob) or len(ob.node_tree.nodes)<MIN_NODES:
                        continue
                mats.append(ob)
                ob.asset_mark()
                ob.asset_data.tags.new(ob.name)
                if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(MATS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Materials/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
                if not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS:
                    ob.asset_generate_preview()
    bpy.app.timers.register(functools.partial(create_preview,"MATS",mats,mats),first_interval=0)

def Create_World_Assets():
    worlds=[]
    if "WORLDS" in FILTERS and (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(WORLDS_PATH,os.path.basename(FILEPATH)))):
        for ob in bpy.data.worlds:
            if (WHAT_TO_SAVE=='Everything' or (WHAT_TO_SAVE=='Non-Asset' and not ob.asset_data) or (WHAT_TO_SAVE=='Marked Assets' and ob.asset_data)):
                worlds.append(ob)
                ob.asset_mark()
                ob.asset_data.tags.new(ob.name)
                if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(WORLDS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Worlds/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
                if not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS:
                    ob.asset_generate_preview()
    bpy.app.timers.register(functools.partial(create_preview,"WORLDS",worlds,worlds),first_interval=0)
def Create_NodeGroup_Assets():
    groups=[]
    groups_to_check_previews=[]
    if OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(WORLDS_PATH,os.path.basename(FILEPATH))):
        if "NODEGROUPS" in FILTERS:
            for ob in bpy.data.node_groups:
                if ob.bl_idname == 'ShaderNodeTree'  and (WHAT_TO_SAVE=='Everything' or (WHAT_TO_SAVE=='Non-Asset' and not ob.asset_data) or (WHAT_TO_SAVE=='Marked Assets' and ob.asset_data)):
                    groups.append(ob)
                    ob.asset_mark()
                    ob.asset_data.tags.new(ob.name)
                    if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(NODEGROUPS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Node Groups/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
                    if does_support_thumbnails(ob):
                        groups_to_check_previews.append(ob)
                        if (not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS)  and [a for a in ob.interface.items_tree if a.in_out=='OUTPUT']:
                            Create_Node_Group_Asset(None,ob,ENGINE)
    bpy.app.timers.register(functools.partial(create_preview,"NODEGROUPS",groups,groups_to_check_previews),first_interval=0)
def copy_attributes( old_node, new_node):
        for i in range(len(old_node.inputs)):
            new_node.inputs[i].default_value=old_node.inputs[i].default_value 
def Create_Node_Group_Asset(node,node_group,engine="CYCLES"):
    
    node_group.asset_mark()
    node_group.asset_data.tags.new(node_group.name)
    if CATALOG!='NONE':
            node_group.asset_data.catalog_id=create_new_catalog(NODEGROUPS_PATH if not SAVE_AS_SINGLE_BLEND_FILE else BLENDS_PATH,('Node Groups/' if SAVE_AS_SINGLE_BLEND_FILE else '')+(decode_catalog_name(CATALOG)))
    if not (node_group.preview and any(node_group.preview.image_pixels[:])) or FORCE_PREVIEWS:
        if not os.path.isdir(os.path.join(NODEGROUPS_PATH,"Thumbnails")):
            os.mkdir(os.path.join(NODEGROUPS_PATH,"Thumbnails"))
        scene_backup=context.scene
        if not bpy.data.scenes.get('TA_Node_Group_Render_Setup'):
            setup_file_path=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "NodeGroupStudio.blend","Scene")
            bpy.ops.wm.append(
                    directory=setup_file_path,
                    filename="TA_Node_Group_Render_Setup", autoselect=False
                )
        context.window.scene=bpy.data.scenes.get('TA_Node_Group_Render_Setup')
        material=bpy.data.materials.get('TA_Node_Group_Shader')
        group_node=material.node_tree.nodes.new(type='ShaderNodeGroup')
        group_node.node_tree=node_group
        if node:
            copy_attributes(node,group_node)
        material.node_tree.links.new(group_node.outputs[0],material.node_tree.nodes.get('ToConnect').inputs[0])
        r=context.scene.render
        r.engine=engine
        r.image_settings.file_format = 'PNG'
        r.image_settings.quality = 95
        r.resolution_x = 256
        r.resolution_y =  256
        r.resolution_percentage = 100
        path=os.path.join(NODEGROUPS_PATH,"Thumbnails",node_group.name+get_id(8)+".png")
        r.filepath = path
        bpy.ops.render.render(write_still=True)
        context.window.scene =scene_backup

        if os.path.isfile(path):
            with context.temp_override(id=node_group):
               bpy.ops.ed.lib_id_load_custom_preview(filepath=path)
bpy.ops.file.make_paths_absolute()
if KITBASH_ASSETS:
    if not JOIN_CHILDREN:
        FILTERS=FILTERS+","+"COLLECTIONS"
        FILTERS=FILTERS.replace('MESH','')
        FILTERS=FILTERS.replace('CURVE','')
        FILTERS=FILTERS.replace('SURFACE','')
        FILTERS=FILTERS.replace('CAMERA','')
        FILTERS=FILTERS.replace('LIGHT','')
        FILTERS=FILTERS.replace('FONT','')
        FILTERS=FILTERS.replace('VOLUME','')
        FILTERS=FILTERS.replace('GPENCIL','')
        FILTERS=FILTERS.replace('META','')
        FILTERS=FILTERS.replace('NODEGROUPS','')
    for scene in bpy.data.scenes:
        join_meshes_with_same_parent(scene)
if PACK:
    try:
        bpy.ops.file.pack_all()
    except Exception as e:
        print(e)
Create_Collection_Assets()
