
import bpy
import sys
import os
import time
import functools
import mathutils
import random
import uuid
import addon_utils
import re
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
bpy.ops.preferences.addon_enable(module="True-Assets")
def preferences():
    return bpy.context.preferences.addons[__package__].preferences
# true_assets_location=os.path.join(os.path.dirname(os.path.dirname(__file__)),"True-Assets")
true_assets_location=os.path.dirname(__file__)
# print(true_assets_location)
FILEPATHS= argv[0].split(":-path-:")
print("Files: ",FILEPATHS)
FILEPATH=FILEPATHS.pop(0)
IMPORTER='Blender'
ADD_PLANE=True
CATALOG='Filename'
SHADING='MATERIAL'
OVERRIDE='COPY'
FORCE_PREVIEWS=True
WORLD_STRENGTH=2
CAMERA_ANGLE='XY'
OBJECTS_PATH=preferences().objects_directory
supports_thumbnails=['MESH','LIGHT']
context = bpy.context
scene = context.scene
st=time.time()

bpy.ops.wm.read_homefile(app_template="")
bpy.context.preferences.system.texture_collection_rate=5
bpy.context.preferences.system.texture_time_out=5
for o in bpy.data.objects:
    bpy.data.objects.remove(o)
random_id_source = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
def decode_catalog_name(catalog):
    if catalog=='Filename':
        return os.path.splitext(os.path.basename(FILEPATH))[0]
    elif catalog=='Directory':
        return os.path.basename(os.path.dirname(FILEPATH))
    else:return catalog
def get_id(length=6):
    return "".join(random.sample(random_id_source, length))
def find_scene_from_object(object):
    for s in bpy.data.scenes:
        if object in s.objects[:]:
            return s
    return None

def get_random_uuid():
    return str(uuid.uuid4())
def get_name_to_display(name):
    if "/" in name:
        #substr=name[name.rindex("/")+1:]
        return name[name.rindex("/")+1:] +f" ({name[:name.rindex('/')]})"
    else:
        return name
def get_catalog_by_name(path,name):
    if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='r',newline="\n",encoding="UTF-8") as catalog_file:
            for l in catalog_file.readlines():
                if not l.startswith("#") and not l.startswith("VERSION") and ":" in l:
                    if l[l.index(":")+1:l.rindex(":")]==name:
                        return l[:l.index(":")]
    return None
def create_new_catalog(path,name):
    uuids=[]
    #uuid=get_random_uuid()
    result = [_.start() for _ in re.finditer("/",name )] +[len(name),]
    for a in range(len(result)):
        uuids.append(get_random_uuid())
    if not os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='w+',newline="\n",encoding="UTF-8") as catalog_file:
            catalog_file.writelines(["\nVERSION 1",])
            for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    else:
        
        if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
            with open(os.path.join(path,"blender_assets.cats.txt"), mode='a',newline="\n",encoding="UTF-8") as catalog_file:
                for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    
    return get_catalog_by_name(path,name) if get_catalog_by_name(path,name) else "00000000-0000-0000-0000-000000000000"
def delete_object_with_data(obj):
    if obj and obj.name in bpy.data.objects:
        data = obj.data
        isMesh = obj.type == 'MESH'
        bpy.data.objects.remove(obj, do_unlink=True)
        if isMesh:
            bpy.data.meshes.remove(data)
def get_bounding_box_of_collection(col):
    corners=[]
    for ob in col.all_objects:
        corners.extend([(ob.matrix_world @ mathutils.Vector(b)) for b in ob.bound_box])
    min_z=min(((mathutils.Vector(b)).z for b in corners))
    max_z=max(((mathutils.Vector(b)).z for b in corners))
    min_x=min(((mathutils.Vector(b)).x for b in corners))
    max_x=max(((mathutils.Vector(b)).x for b in corners))
    min_y=min(((mathutils.Vector(b)).y for b in corners))
    max_y=max(((mathutils.Vector(b)).y for b in corners))
    return mathutils.Vector((min_x,min_y,min_z)),mathutils.Vector((max_x,max_y,max_z))
def get_collections_from_scene(scene):
    return [c for c in bpy.data.collections if scene.user_of_id(c)]
def get_biggest_object_from(col):
    if col.all_objects:

        max_volume_object=col.all_objects[0]
        for object in col.all_objects:
            if object.dimensions.x*object.dimensions.y*object.dimensions.z>max_volume_object.dimensions.x*max_volume_object.dimensions.y*max_volume_object.dimensions.z:
                max_volume_object=object
        return object
    return None
def capture_thumbnail_for_collection(context,col,path, shading="Material",angle='X',add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene=context.scene  
    scene.render.image_settings.file_format = 'PNG'
    if col not in get_collections_from_scene(scene):
        scene.collection.children.link(col)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(col.name+"_"+get_id(8))+'.png')
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    bottom_left,top_right=get_bounding_box_of_collection(col)
    local_bbox_center =(bottom_left+top_right)/2
    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        scene.collection.objects.link(ground_plane)
        min_z=bottom_left.z
        ground_plane.location=(local_bbox_center.x, local_bbox_center.y,min_z)
    global_bbox_center = local_bbox_center
    track_object.location=global_bbox_center
    dist=max([abs(top_right.x-bottom_left.x),abs(top_right.y-bottom_left.y),abs(top_right.z-bottom_left.z)])*2
    object=get_biggest_object_from(col)
    if object:
        object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
        camera_object.location=object_matrix@mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    else:
        camera_object.location=mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))    
    
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    #override = context.copy()
    #override["object"] = camera_object
    with context.temp_override(object=camera_object):
        bpy.ops.constraint.apply(constraint=constraint.name)
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    for area in context.window_manager.windows[0].screen.areas:
            area.type='VIEW_3D'
            #override['scene']=scene
            override['area']=area
            override['space_data']=area.spaces[0]
            override['screen']=context.window_manager.windows[0].screen
            override['window']=context.window_manager.windows[0]
            area.spaces[0].region_3d.view_perspective = 'CAMERA'
            override['active']=col.all_objects[0] if col.all_objects else None
            if col.all_objects:
                override['selected_objects']=[col.all_objects[0],]
            view_area=area
            break
                
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    context.scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=context.scene.world.node_tree.nodes.get("Mapping")
    context.scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]          
    if shading=='Material' or shading=='Solid-TA':
        
        view_area.spaces[0].shading.type = 'MATERIAL' if shading == 'Material' else 'SOLID'
        view_area.spaces[0].overlay.show_overlays = False
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_viewport == False:
                obj.hide_viewport = True
                hidden.append(obj)
        with context.temp_override(**override):
            bpy.ops.render.opengl(write_still=True)
        for obj in hidden:
            obj.hide_viewport = False
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
        
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    if ground_plane:
        delete_object_with_data(ground_plane)
    scene.camera = cameraBackUp
    return render_path
def capture_thumbnail(context,object,path, shading="Material",angle='X',add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene=context.scene 
    scene.render.image_settings.file_format = 'PNG' 
    if object not in scene.objects[:]:
        scene.collection.objects.link(object)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(object.name+"_"+get_id(8))+'.png')
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    local_bbox_center = 0.125 * sum((mathutils.Vector(b) for b in object.bound_box), mathutils.Vector())
    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        scene.collection.objects.link(ground_plane)
        min_z=min(((object.matrix_world @ mathutils.Vector(b)).z for b in object.bound_box))
        ground_plane.location=(object.location.x, object.location.y,min_z)
    global_bbox_center = object.matrix_world @ local_bbox_center
    track_object.location=global_bbox_center
    dist=max(object.dimensions[:])*2
    object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
    camera_object.location=object_matrix@mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    
    
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    #override = context.copy()
    #override["object"] = camera_object
    with context.temp_override(object=camera_object):
        bpy.ops.constraint.apply(constraint=constraint.name)
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    for area in context.window_manager.windows[0].screen.areas:
            area.type='VIEW_3D'
            #override['scene']=scene
            override['area']=area
            override['space_data']=area.spaces[0]
            override['screen']=context.window_manager.windows[0].screen
            override['window']=context.window_manager.windows[0]
            area.spaces[0].region_3d.view_perspective = 'CAMERA'
            override['active']=object
            override['selected_objects']=[object,]
            view_area=area
            break
                
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    context.scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=context.scene.world.node_tree.nodes.get("Mapping")
    context.scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]          
    if shading=='Material' or shading=='Solid-TA':
        
        view_area.spaces[0].shading.type = 'MATERIAL' if shading == 'Material' else 'SOLID'
        view_area.spaces[0].overlay.show_overlays = False
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.hide_get() == False:
                obj.hide_set(True)
                hidden.append(obj)
        og_hide_render=object.hide_render
        object.hide_render=False
        bpy.ops.render.render(write_still=True)
        object.hide_render=og_hide_render
        for obj in hidden:
            obj.hide_set(False)
    
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
        
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    if ground_plane:
        delete_object_with_data(ground_plane)
    scene.camera = cameraBackUp
    return render_path
def create_thumbnail(context, ob,shading='Solid'):
    if not os.path.isdir(os.path.join(OBJECTS_PATH,'Thumbnails')):
        os.mkdir(os.path.join(OBJECTS_PATH,'Thumbnails'))
    if shading!='Solid':
        if isinstance(ob,bpy.types.Collection):
            path=capture_thumbnail_for_collection(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
        else:
            path=capture_thumbnail(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
            
        if os.path.isfile(path):
            with context.temp_override(id=ob):
                bpy.ops.ed.lib_id_load_custom_preview( filepath=path)
    else:
        ob.asset_generate_preview()

def check_if_volumetric(mat):
    if mat.use_nodes:
        output_nodes=[node for node in mat.node_tree.nodes if node.bl_idname=='ShaderNodeOutputMaterial']
        for node in output_nodes:
            if node.inputs[1].is_linked:
                return True
def create_preview(type,objects,objects_to_check_previews):
    global FILEPATH,FILEPATHS,st
    obs=objects_to_check_previews[:]
    obs=objects_to_check_previews[:]
    while obs:
        ob=obs[0]
        if not ob.preview or any(ob.preview.image_pixels[:]) or ((type=='COLLECTIONS' or type=='OBJECTS') and SHADING!="Solid") or (type=='MATS' and check_if_volumetric(ob)):
            
            obs.pop(0)
        else:
            return 1
    if type!='COLLECTIONS':
        write_to_blend(type, objects)
    if type=="COLLECTIONS":
        Create_Mesh_Assets(objects)
    else:
        if FILEPATHS:
            FILEPATH=FILEPATHS.pop(0)
            bpy.ops.wm.read_homefile(app_template="")
            bpy.context.preferences.system.texture_collection_rate=5
            bpy.context.preferences.system.texture_time_out=5
            for o in bpy.data.objects:
                bpy.data.objects.remove(o)
            if IMPORTER=='Better FBX':
                bpy.ops.better_import.fbx(filepath=FILEPATH,)

            else:
                if os.path.splitext(FILEPATH)[1]=='.fbx':
                    bpy.ops.import_scene.fbx(filepath=FILEPATH,)     
                elif os.path.splitext(FILEPATH)[1]=='.obj':
                    bpy.ops.import_scene.obj(filepath=FILEPATH ,)                 
                elif os.path.splitext(FILEPATH)[1]=='.usdz':
                    override=context.copy()
                    for area in context.window_manager.windows[0].screen.areas:
                            area.type='VIEW_3D'
                            override['window']=context.window_manager.windows[0]
                            break
                    with context.temp_override(**override):
                        bpy.ops.wm.usd_import(filepath=FILEPATH ,)  
            print(bpy.data.objects[:])
            bpy.ops.file.pack_all()
            # bpy.ops.file.make_paths_absolute()
            Create_Collection_Assets()
        else:
            pass
            # bpy.ops.wm.quit_blender()
    return None
def get_available_name(path,name):
    name=name.replace(".blend","")
    new_name=name
    if os.path.isdir(path):
        files = [file for file in os.listdir(path)]
        final_name = name
        i = 1
        while (final_name+".blend" in files):
            final_name = name+f"_{i}"
            i = i+1
        new_name = final_name
    return new_name+".blend"
def write_to_blend(type, objects):
    blend_name=os.path.basename(FILEPATH)
    blend_name=os.path.splitext(blend_name)[0]+'.blend'
    print(blend_name,OVERRIDE)
    if objects:
        if type=="OBJECTS":
            if OVERRIDE=='COPY':
                blend_name=get_available_name(OBJECTS_PATH,blend_name)
            path=os.path.join(OBJECTS_PATH,blend_name)
        bpy.data.libraries.write(path
                        , set(objects), fake_user=True)
    


def Create_Collection_Assets():
    objects=[]
    objects_to_check_previews=[]
    data_used=[]
    if (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(OBJECTS_PATH,os.path.basename(FILEPATH)))):
        for scene in bpy.data.scenes:
            for ob in [c for c in bpy.data.collections if scene.user_of_id(c)]:
                if not ob.hide_viewport and ob not in data_used and [a for a in ob.all_objects if a.type!='EMPTY']:
                    data_used.append(ob)
                    ob.name=os.path.splitext(os.path.basename(FILEPATH))[0]
                    ob.asset_mark()
                    ob.asset_data.tags.new(ob.name)
                    if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(OBJECTS_PATH,decode_catalog_name(CATALOG))
                    objects.append(ob)
                    objects_to_check_previews.append(ob)
                    if not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS:
                        create_thumbnail(context,ob,SHADING)
                    
                    #ob.asset_generate_preview()
    create_preview("COLLECTIONS",objects,objects_to_check_previews)
    # bpy.app.timers.register(functools.partial(
    # create_preview, "COLLECTIONS",objects,objects_to_check_previews), first_interval=0)
def does_support_thumbnails(ob):
    return isinstance(ob,bpy.types.Material) or isinstance(ob,bpy.types.World) or  (isinstance(ob,bpy.types.Object) and ob.type in supports_thumbnails and not (isinstance(ob,bpy.types.Object) and ob.type=='MESH' and len(ob.evaluated_get(bpy.context.evaluated_depsgraph_get()).data.polygons)<1)) or (isinstance(ob,bpy.types.NodeTree) and [a for a in ob.interface.items_tree if a.in_out=='OUTPUT']) or SHADING!='Solid'
def get_all_nodegroups_from_material(node_tree):
    groups=[]
    for node in node_tree.nodes:
        if node.type=='GROUP':
            groups.append(node.node_tree)
            groups.extend(get_all_nodegroups_from_material(node.node_tree))
    return groups

def Create_Mesh_Assets(collection_objects):
    objects=[]
    objects_to_check_previews=[]
    data_used=[]
    if False and (OVERRIDE!="SKIP" or not os.path.isfile(os.path.join(OBJECTS_PATH,os.path.basename(FILEPATH)))):
        for scene in bpy.data.scenes:
            for ob in scene.objects:
                if ob.type=='MESH' and ob.data not in data_used:
                    data_used.append(ob.data)
                    if ob.type=='MESH' and (ob.display_type == 'WIRE' or ob.display_type == 'BOUNDS' ):
                        continue    
                    if ob.type in {'MESH','CURVE','SURFACE','TEXT','META'}:
                        ob.display_type='TEXTURED'
                    ob.asset_mark()
                    ob.asset_data.tags.new(ob.name)
                    ob.asset_data.tags.new(ob.type.title())
                    if CATALOG!='NONE':
                        ob.asset_data.catalog_id=create_new_catalog(OBJECTS_PATH,decode_catalog_name(CATALOG))
                    objects.append(ob)
                    if does_support_thumbnails(ob):
                        objects_to_check_previews.append(ob)
                        if not (ob.preview and any(ob.preview.image_pixels[:])) or FORCE_PREVIEWS:
                            create_thumbnail(context,ob,SHADING)
                    
                    #ob.asset_generate_preview()
    # create_preview("OBJECTS",objects+collection_objects,objects_to_check_previews)
    create_preview("OBJECTS",objects+collection_objects,objects+collection_objects)
    # bpy.app.timers.register(functools.partial(
    # create_preview, "OBJECTS",objects+collection_objects,objects_to_check_previews), first_interval=0)
if IMPORTER=='Better FBX':
    bpy.ops.better_import.fbx(filepath=FILEPATH,)   
    
else:
    print(FILEPATH,os.path.splitext(FILEPATH)[1])
    if os.path.splitext(FILEPATH)[1]=='.fbx':
        bpy.ops.import_scene.fbx(filepath=FILEPATH,)     
    elif os.path.splitext(FILEPATH)[1]=='.obj':
        print("Loading",FILEPATH)
        bpy.ops.import_scene.obj(filepath=FILEPATH ,)  
    elif os.path.splitext(FILEPATH)[1]=='.usdz':
        override=context.copy()
        for area in context.window_manager.windows[0].screen.areas:
                area.type='VIEW_3D'
                override['window']=context.window_manager.windows[0]
                break
        with context.temp_override(**override):
    
            bpy.ops.wm.usd_import(filepath=FILEPATH,)  
bpy.ops.file.pack_all()
# bpy.ops.file.make_paths_absolute()
# print(bpy.data.objects[:])
Create_Collection_Assets()
#Create_Mesh_Assets()
