import bpy
import sys
import os
import functools
import re
import uuid
from bpy.utils import register_class
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
TYPE= argv[0]
FOLDER_PATH=argv[1]
SELECTED_FILES=argv[2].split(":--separator--:") if argv[2]!="None" else None
MATS_DIRECTORY=argv[3]
CATALOG=argv[4]
PACK=eval(argv[5])
SEARCH=argv[6]
INPUT_NAMES=argv[7].split(":--separator--:") if argv[7]!="None" else None
INPUT_VALUES=argv[8].split(":--separator--:") if argv[8]!="None" else None
MATS_PER_FILE:3
def decode_catalog_name(catalog,path):
    if catalog=='Filename':
        return os.path.splitext(os.path.basename(path))[0]
    elif catalog=='Directory':
        relative_path = os.path.relpath(path, os.path.dirname(os.path.dirname(FOLDER_PATH))).replace(os.sep,'/')
        return os.path.dirname(relative_path)
        return os.path.basename(os.path.dirname(path))
    elif catalog=='Directory_PH':
        if os.path.basename(path).lower()=='textures':
            path=os.path.dirname(path)
        relative_path = os.path.relpath(path, os.path.dirname(os.path.dirname(FOLDER_PATH))).replace(os.sep,'/')
        return os.path.dirname(relative_path)
    else:return catalog
def create_dict(list1,list2):
    result={}
    if len(list1)==len(list2):
        for i,a in enumerate(list1):
            result[a]=list2[i]
    return result
SHADER_VALUES=create_dict(INPUT_NAMES,INPUT_VALUES)
bpy.types.Node.is_ta_node=bpy.props.BoolProperty(default=False)
def update_node_toggle(self,context):
    index=1
    node=[a for a in self.id_data.nodes if a.is_ta_node]
    if node:
        node=node[0]
        for toggle in [a for a in node.inputs if '*t' in a.name]:
            if getattr(self,f"toggle_{index}"):
                toggle.default_value=1
            else:
                toggle.default_value=0
            index+=1
class TA_NODE_TOGGLES(bpy.types.PropertyGroup):
    toggle_1:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_2:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_3:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_4:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_5:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_6:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_7:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_8:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_9:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_10:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_11:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_12:bpy.props.BoolProperty(default=False,update=update_node_toggle)
register_class(TA_NODE_TOGGLES)
bpy.types.Node.ta_toggles=bpy.props.PointerProperty(type=TA_NODE_TOGGLES)
bpy.context.preferences.system.texture_collection_rate=5
bpy.context.preferences.system.texture_time_out=5
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
def get_random_uuid():
    return str(uuid.uuid4())
def get_name_to_display(name):
    if "/" in name:
        #substr=name[name.rindex("/")+1:]
        return name[name.rindex("/")+1:] +f" ({name[:name.rindex('/')]})"
    else:
        return name
def get_catalog_by_name(path,name):
    if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='r',newline="\n",encoding="UTF-8") as catalog_file:
            for l in catalog_file.readlines():
                if not l.startswith("#") and not l.startswith("VERSION") and ":" in l:
                    if l[l.index(":")+1:l.rindex(":")]==name:
                        return l[:l.index(":")]
    return None

def create_new_catalog(path,name):
    uuids=[]
    #uuid=get_random_uuid()
    result = [_.start() for _ in re.finditer("/",name )] +[len(name),]
    for a in range(len(result)):
        uuids.append(get_random_uuid())
    if not os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='w+',newline="\n",encoding="UTF-8") as catalog_file:
            catalog_file.writelines(["\nVERSION 1",])
            for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    else:
        
        if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
            with open(os.path.join(path,"blender_assets.cats.txt"), mode='a',newline="\n",encoding="UTF-8") as catalog_file:
                for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    
    return get_catalog_by_name(path,name) if get_catalog_by_name(path,name) else "00000000-0000-0000-0000-000000000000"
def get_available_name(path,name):
    name=name.replace(".blend","")
    new_name=name
    if os.path.isdir(path):
        files = [file for file in os.listdir(path)]
        final_name = name
        i = 1
        while (final_name+".blend" in files):
            final_name = name+f"_{i}"
            i = i+1
        new_name = final_name
    return new_name+".blend"
def write_to_blend(objects,override,custom_name=None):
    blend_name=os.path.basename(bpy.data.filepath)
    if objects:
        if custom_name:
            blend_name=custom_name+".blend"
        if override=='COPY':
            blend_name=get_available_name(MATS_DIRECTORY,blend_name)
        path=os.path.join(MATS_DIRECTORY,blend_name)
    
        bpy.data.libraries.write(path
                        , set(objects), fake_user=True)
def split_array_by_first_element(arr):
    """
    Split an array of tuples based on the first element of each tuple.

    Parameters:
        arr (list or tuple): The array to be split.

    Returns:
        dict: A dictionary with keys as unique first elements and values as the corresponding tuples.
    """
    result = {}
    for item in arr:
        key = item[0]
        if key in result:
            result[key].append(item[1:])
        else:
            result[key] = [item[1:]]
    return result
def create_material_preview(objects,images,pack=False):
    obs=objects[:]
    while obs:
        ob=obs[0]
        if any(ob.preview.image_pixels[:]):
            obs.pop(0)
        else:
            return 0.1
    packed_images=[]
    if pack:
        for dir,mat,i in images:
            packed_images.append(i)
            i.pack()
    for dir,mats_and_images in split_array_by_first_element(images).items():
        data_to_write=set()
        for mat,image in mats_and_images:
            data_to_write.add(mat)
            data_to_write.add(image)
        write_to_blend(data_to_write,'COPY',os.path.basename(dir))
    for i in packed_images:
        i.unpack(method='REMOVE')
    bpy.ops.wm.quit_blender()
    return None
def clear_mat_name(name):
    return name.replace("1K","").replace("2K","").replace("4K","").replace("6K","").replace("8K","").replace("12K","").replace("12K","").strip()
def get_matching_catalog(name,catalogs):
    for c in sorted(catalogs,key=lambda x:len(x)):
        if c.lower() in name.lower():
            return c
    return None
def sortTextures(textures):
    BaseColor = None
    Roughness = None
    Normal = None
    Height = None
    Metal = None
    Specular = None
    opacity = None
    ao=None
    emit=None
    len = 0
    BaseColorTags = ['diffuse', 'diff', 'albedo', 'base', 'col', 'color']
    RoughnessTags = ['roughness', 'rough', 'rgh','gloss']
    NormalTags = ['normal', 'nor', 'nrm', 'nrml', 'norm']
    HeightTags = ['displacement', 'displace', 'disp',
                  'dsp', 'height', 'heightmap', 'bmp', 'bump']
    MetallicTags = ['metallic', 'metalness', 'mtl']
    SpecularTags = ['specularity', 'specular', 'spec', 'spc']
    opacityTags = ['opacity', 'alpha', ' transparen']
    aoTags=['ao','occlusion']
    emitTags=['emis','emit']
    for tex in textures:
        if any(x in tex.lower() for x in BaseColorTags) and BaseColor is None:
            BaseColor = tex
            len = len+1
        elif any(x in tex.lower() for x in RoughnessTags) and Roughness is None:
            Roughness = tex
            len = len+1
        elif any(x in tex.lower() for x in NormalTags) and Normal is None:
            Normal = tex
            len = len+1
        elif any(x in tex.lower() for x in HeightTags) and Height is None:
            Height = tex
            len = len+1
        elif any(x in tex.lower() for x in MetallicTags) and Metal is None:
            Metal = tex
            len = len+1
        elif any(x in tex.lower() for x in SpecularTags) and Specular is None:
            Specular = tex
            len = len+1
        elif any(x in tex.lower() for x in opacityTags) and opacity is None:
            opacity = tex
            len = len+1
        elif any(x in tex.lower() for x in aoTags) and ao is None:
            ao = tex
            len = len+1
        elif any(x in tex.lower() for x in emitTags) and emit is None:
            emit = tex
            len = len+1
    return[BaseColor, Roughness, Normal, Height, Metal, Specular, opacity,ao,emit, len]


def get_quality(content):
    if content:
        if "1K" in content[0] or "1024" in content[0]:
            return "1K", 1
        elif "2K" in content[0] or "2048" in content[0]:
            return "2K", 2
        elif "4K" in content[0] or "4096" in content[0]:
            return "4K", 4
        elif "8K" in content[0] or "8192" in content[0]:
            return "8K", 8
        elif "6K" in content[0] or "6144" in content[0]:
            return "6K", 6
        elif "12K" in content[0]:
            return "12K", 12
        elif "16K" in content[0]:
            return "16K", 16
    return "", 4
def longest_substr(str1, str2):
    for i in range(min(len(str1), len(str2))):
        if str1[i] != str2[i]: return str1[0:i]
    return str1[0:i+1]
def distribute(original_strings):
    strings = original_strings.copy()
    groups = []
    while len(strings) > 0:
        group = [strings[0]]
        rem_strings = []
        substr = strings[0]
        strings.pop(0)
        for string in strings:
            new_substr = longest_substr(string, substr)
            #print(new_substr)
            if "_" in string:
                max_length=string.index("_")
            else:
                max_length=1
            if new_substr and len(new_substr) > max_length:
                group.append(string)
                substr = new_substr
            else:
                rem_strings.append(string)
        groups.append({"contents": group, "common": substr})
        strings = rem_strings
        #print(groups)

    return groups
def distribute_mat_names(original_strings):
    strings = original_strings.copy()
    groups = []
    while len(strings) > 0:
        group = [strings[0]]
        rem_strings = []
        substr = strings[0]
        strings.pop(0)
        for string in strings:
            new_substr = longest_substr(string, substr)
            #print(new_substr)
            res = re.findall("[A-Za-z]*", string)[0]
            max_length=len(res)
            if new_substr and len(new_substr) > max_length:
                group.append(string)
                substr = new_substr
            else:
                rem_strings.append(string)
        groups.append({"contents": group, "common": substr})
        strings = rem_strings
        #print(groups)
    return groups
def set_toggles(node_group):
    i=1
    for inp in node_group.inputs:
        if '*t' in inp.name:
            if inp.default_value==1:
                setattr(node_group.ta_toggles,f'toggle_{i}',True)
            i+=1
def setup_materials(type,folder_path,selected_files,only_basecolor=False, catalog=None,pack=False):
    mats_created = []
    filename = type
    images_used=[]
    file_path = os.path.join(os.path.dirname(
        os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend", "Material")
    if os.path.isdir(folder_path):
        matInit = []

        for m in bpy.data.materials:
            matInit.append(m.name)
        bpy.ops.wm.append(
            directory=file_path,
            filename=filename, autoselect=False
        )
        matAfter = []

        for m in bpy.data.materials:
            matAfter.append(m.name)
        mat = [a for a in matAfter if a not in matInit]
        mat = bpy.data.materials.get(mat[0])
        for i, j, y in os.walk(folder_path):
            files = []
            
            for name in os.listdir(i):
                if selected_files:
                    if (name.endswith('jpg') or name.endswith('png') or name.endswith('jpeg') or name.endswith('exr') or name.endswith('tif')) and name in selected_files and SEARCH.lower() in name.lower() and not name.startswith('.'):
                        
                        files.append(os.path.basename(name))
                else:
                    if (name.endswith('jpg') or name.endswith('png') or name.endswith('jpeg') or name.endswith('exr') or name.endswith('tif')) and SEARCH.lower() in name.lower() and not name.startswith('.'):
                        
                        files.append(os.path.basename(name))
            if len(files) > 1:
                dir_name_to_remove='XXXXXXXXXXXXXXX'
                groups = distribute(files)
                if len(groups)==len(files):
                    dir_name_to_remove=os.path.basename(i)+"_"
                    groups=distribute([os.path.basename(i)+"_"+a for a in files])
                for group in groups:
                    tex = sortTextures([a.replace(dir_name_to_remove,'') for a in group['contents']])
                    if tex[9] > 1 or (tex[0] is not None and only_basecolor):
                        newMat = mat.copy()
                        
                        newMat.use_fake_user = True
                        nodes_to_arrange=[]
                        newMat.name = group['common'].replace(
                            '_', ' ')+get_quality(group['contents'])[0]
                        if type!='Standard':
                            node_group=newMat.node_tree.nodes.get(type)
                            node_group.node_tree=node_group.node_tree.copy()
                            node_group.name=newMat.name
                            node_group.node_tree.name=newMat.name
                            node_group.is_ta_node=True
                            for inp,value in SHADER_VALUES.items():
                                try:
                                    inp=[a.name for a in node_group.inputs if  a.name.lower().startswith(inp.lower())][0]
                                    node_group.inputs[inp].default_value=eval(value)
                                except Exception as e:
                                    print(inp,value,e)
                            if tex[2]:

                                try:
                                    if 'dx' in tex[2].lower():
                                        node_group.inputs['DX to OGL Normals*t'].default_value=0
                                    if 'gl' in tex[2].lower():
                                        node_group.inputs['DX to OGL Normals*t'].default_value=1
                                except Exception:
                                    pass
                                
                            set_toggles(node_group)
                        else:
                            node_group=newMat
                            
                        if node_group:
                            if node_group.node_tree.nodes.get("AO"):
                                if tex[7] is not None:
                                    node_group.node_tree.nodes["AO"].image = bpy.data.images.load(
                                        os.path.join(i, tex[7]))
                                    node_group.node_tree.links.new(node_group.node_tree.nodes["AO"].outputs[0],node_group.node_tree.nodes["AO Mix"].inputs[7 if len(node_group.node_tree.nodes["AO Mix"].inputs)>5 else 2])
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["AO"].image))
                                    nodes_to_arrange.append(node_group.node_tree.nodes["AO"])
                            if node_group.node_tree.nodes.get("BaseColor"):
                                if tex[0] is not None:
                                    node_group.node_tree.nodes["BaseColor"].image = bpy.data.images.load(
                                        os.path.join(i, tex[0]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["BaseColor"].image))
                                    nodes_to_arrange.append(node_group.node_tree.nodes["BaseColor"])
                            if  node_group.node_tree.nodes.get("Metallic"):
                                if tex[4] is not None:
                                    node_group.node_tree.nodes["Metallic"].image = bpy.data.images.load(
                                        os.path.join(i, tex[4]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Metallic"].image))
                                    node_group.node_tree.nodes["Metallic"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Metallic"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Metallic"])
                            if node_group.node_tree.nodes.get("Specular"):
                                if tex[5] is not None:
                                    node_group.node_tree.nodes["Specular"].image = bpy.data.images.load(
                                        os.path.join(i, tex[5]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Specular"].image))
                                    node_group.node_tree.nodes["Specular"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Specular"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Specular"])
                            if node_group.node_tree.nodes.get("Roughness"):
                                if tex[1] is not None:
                                    node_group.node_tree.nodes["Roughness"].image = bpy.data.images.load(
                                        os.path.join(i, tex[1]))
                                    
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Roughness"].image))
                                    node_group.node_tree.nodes["Roughness"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Roughness"])
                                    if "gloss" in tex[1].lower():
                                        roughness_socket=node_group.node_tree.nodes["Roughness"].outputs[0].links[0].to_socket
                                        invert_node=node_group.node_tree.nodes.new('ShaderNodeInvert')
                                        invert_node.location=node_group.node_tree.nodes["Roughness"].location.x+300,node_group.node_tree.nodes["Roughness"].location.y
                                        node_group.node_tree.links.new(node_group.node_tree.nodes["Roughness"].outputs[0],invert_node.inputs[1])
                                        node_group.node_tree.links.new(invert_node.outputs[0],roughness_socket)
                                        node_group.node_tree.nodes["Roughness"].label="Glossiness"
                                        node_group.node_tree.nodes["Roughness"].name="Glossiness"
                                        
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Roughness"])
                            if node_group.node_tree.nodes.get("Emission"):
                                if tex[8] is not None:
                                    node_group.node_tree.nodes["Emission"].image = bpy.data.images.load(
                                        os.path.join(i, tex[8]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Emission"].image))
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Emission"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Emission"])
                            if node_group.node_tree.nodes.get("Height"):
                                if tex[3] is not None:
                                    node_group.node_tree.nodes["Height"].image = bpy.data.images.load(
                                        os.path.join(i, tex[3]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Height"].image))
                                    node_group.node_tree.nodes["Height"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Height"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Height"])
                            if node_group.node_tree.nodes.get("Normal"):
                                if tex[2] is not None:
                                    node_group.node_tree.nodes["Normal"].image = bpy.data.images.load(
                                        os.path.join(i, tex[2]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Normal"].image))
                                    node_group.node_tree.nodes["Normal"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Normal"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Normal"])
                            
                                
                            if node_group.node_tree.nodes.get("Opacity"):
                                if tex[6] is not None:
                                    newMat.blend_method = 'CLIP' if newMat.blend_method == 'OPAQUE' else newMat.blend_method
                                    node_group.node_tree.nodes["Opacity"].image = bpy.data.images.load(
                                        os.path.join(i, tex[6]))
                                    images_used.append((os.path.dirname(i) if os.path.dirname(i) else "True Assets Materials",newMat,node_group.node_tree.nodes["Opacity"].image))
                                    node_group.node_tree.nodes["Opacity"].image.colorspace_settings.is_data = True
                                    nodes_to_arrange.append(node_group.node_tree.nodes["Opacity"])
                                else:
                                    node_group.node_tree.nodes.remove(
                                        node_group.node_tree.nodes["Opacity"])
                            if len(nodes_to_arrange)>1:
                                for index,n in enumerate(nodes_to_arrange[1:]):
                                    n.location.y=nodes_to_arrange[index].location.y-(nodes_to_arrange[index].height*(3 if not nodes_to_arrange[index].hide else 1))
                            if True:

                                newMat.asset_mark()
                                newMat.asset_data.tags.new(newMat.name)
                                
                                if catalog=="Directory" or catalog=='Directory_PH':
                                    newMat.asset_data.catalog_id=create_new_catalog(MATS_DIRECTORY,decode_catalog_name(catalog,i))
                                else:
                                    if catalog!="00000000-0000-0000-0000-000000000000" and catalog!='AUTO':
                                        newMat.asset_data.catalog_id=catalog
                                newMat.asset_generate_preview()
                                
                            mats_created.append(newMat)
        
        cats = distribute_mat_names([clear_mat_name(m.name) for m in mats_created if clear_mat_name(m.name)])
        catalogs=[]
        for cat in cats:
            catalogs.append(''.join([i for i in cat['common'] if not i.isdigit()]).title())
        if True and catalog=="AUTO":
            for m in mats_created:
                cat=get_matching_catalog(m.name,catalogs)
                if cat:
                    m.asset_data.catalog_id=create_new_catalog(MATS_DIRECTORY,cat)
        if True and mats_created:
            bpy.app.timers.register(functools.partial(create_material_preview,mats_created,images_used,pack))
        else:
            bpy.ops.wm.quit_blender()
    return mats_created
setup_materials(TYPE,FOLDER_PATH,SELECTED_FILES,False,CATALOG,PACK)