import bpy
import sys
import os
import functools
from bpy.utils import register_class
import re
import uuid
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FOLDER_PATH= argv[0]
SELECTED_FILES=argv[1].split(":--separator--:") if argv[1]!="None" else None
WORLDS_DIRECTORY=argv[2]
SUBFOLDERS=eval(argv[3])
CATALOG=argv[4]
PACK=eval(argv[5])
IMAGE_FILTERS=argv[6].split(":--separator--:")
INPUT_NAMES=argv[7].split(":--separator--:") if argv[7]!="None" else None
INPUT_VALUES=argv[8].split(":--separator--:") if argv[8]!="None" else None
SEARCH=argv[9]
SHADER_TYPE=argv[10]
def get_random_uuid():
    return str(uuid.uuid4())
def get_name_to_display(name):
    if "/" in name:
        #substr=name[name.rindex("/")+1:]
        return name[name.rindex("/")+1:] +f" ({name[:name.rindex('/')]})"
    else:
        return name
def get_catalog_by_name(path,name):
    if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='r',newline="\n",encoding="UTF-8") as catalog_file:
            for l in catalog_file.readlines():
                if not l.startswith("#") and not l.startswith("VERSION") and ":" in l:
                    if l[l.index(":")+1:l.rindex(":")]==name:
                        return l[:l.index(":")]
    return None

def create_new_catalog(path,name):
    uuids=[]
    #uuid=get_random_uuid()
    result = [_.start() for _ in re.finditer("/",name )] +[len(name),]
    for a in range(len(result)):
        uuids.append(get_random_uuid())
    if not os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='w+',newline="\n",encoding="UTF-8") as catalog_file:
            catalog_file.writelines(["\nVERSION 1",])
            for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    else:
        
        if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
            with open(os.path.join(path,"blender_assets.cats.txt"), mode='a',newline="\n",encoding="UTF-8") as catalog_file:
                for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    
    return get_catalog_by_name(path,name) if get_catalog_by_name(path,name) else "00000000-0000-0000-0000-000000000000"
def decode_catalog_name(catalog,path):
    if catalog=='Filename':
        return os.path.splitext(os.path.basename(path))[0]
    elif catalog=='Directory':
        relative_path = os.path.relpath(path, os.path.dirname(os.path.dirname(FOLDER_PATH))).replace(os.sep,'/')
        return os.path.dirname(relative_path)
        return os.path.basename(os.path.dirname(path))
    elif catalog=='ParentDirectory':
        return os.path.basename(os.path.dirname(os.path.dirname(path)))+"/"+os.path.basename(os.path.dirname(path))
    else:return catalog
def create_dict(list1,list2):
    result={}
    if len(list1)==len(list2):
        for i,a in enumerate(list1):
            result[a]=list2[i]
    return result
SHADER_VALUES=create_dict(INPUT_NAMES,INPUT_VALUES)
bpy.types.Node.is_ta_node=bpy.props.BoolProperty(default=False)
def update_node_toggle(self,context):
    index=1
    node=[a for a in self.id_data.nodes if a.is_ta_node]
    if node:
        node=node[0]
        for toggle in [a for a in node.inputs if '*t' in a.name]:
            if getattr(self,f"toggle_{index}"):
                toggle.default_value=1
            else:
                toggle.default_value=0
            index+=1
class TA_NODE_TOGGLES(bpy.types.PropertyGroup):
    toggle_1:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_2:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_3:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_4:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_5:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_6:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_7:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_8:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_9:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_10:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_11:bpy.props.BoolProperty(default=False,update=update_node_toggle)
    toggle_12:bpy.props.BoolProperty(default=False,update=update_node_toggle)
register_class(TA_NODE_TOGGLES)
bpy.types.Node.ta_toggles=bpy.props.PointerProperty(type=TA_NODE_TOGGLES)
#bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
context = bpy.context
scene = context.scene
def get_available_name(path,name):
    name=name.replace(".blend","")
    new_name=name
    if os.path.isdir(path):
        files = [file for file in os.listdir(path)]
        final_name = name
        i = 1
        while (final_name+".blend" in files):
            final_name = name+f"_{i}"
            i = i+1
        new_name = final_name
    return new_name+".blend"
def write_to_blend(objects,override,custom_name=None):
    blend_name=os.path.basename(bpy.data.filepath)
    if objects:
        if custom_name:
            blend_name=custom_name+".blend"
        if override=='COPY':
            blend_name=get_available_name(WORLDS_DIRECTORY,blend_name)
        path=os.path.join(WORLDS_DIRECTORY,blend_name)
        # print(objects)
        bpy.data.libraries.write(path
                        , set(objects), fake_user=True)
def create_world_preview(objects,pack):
    obs=objects[:]
    while obs:
        ob=obs[0]
        if any(ob.preview.image_pixels[:]):
            obs.pop(0)
        else:
            return 0.1
    images=[]
    packed_images=[]
    if pack:
        images=[ob.node_tree.nodes.get("True HDRI").node_tree.nodes.get("Environment Texture").image for ob in objects]
        for i in images:
            packed_images.append(i)
            i.pack()
    write_to_blend(objects+images,'COPY',"True-Assets_HDRIs" if len(objects)>1 else ob.name)
    for i in packed_images:
        i.unpack(method='REMOVE')
    bpy.ops.wm.quit_blender()
    return None
def set_toggles(node_group):
    i=1
    for inp in node_group.inputs:
        if '*t' in inp.name:
            if inp.default_value==1:
                setattr(node_group.ta_toggles,f'toggle_{i}',True)
            i+=1
def setup_hdris(path,selected_files=[],image_filters=["hdr","exr","png","jpeg","jpg"],subfolders=True,catalog=None,pack=False,shader_type='True-HDRI'):
    context=bpy.context
    if not os.path.isdir(os.path.join(WORLDS_DIRECTORY,'Thumbnails')):
        os.mkdir(os.path.join(WORLDS_DIRECTORY,'Thumbnails'))
    created_worlds=[]
    for i, j, y in os.walk(path):
        files = []
        for name in os.listdir(i):
            _,extension=os.path.splitext(name)
            extension=extension.replace(".","")
            if selected_files:
                
                if extension in image_filters and name in [os.path.basename(s) for s in selected_files] and SEARCH.lower() in name.lower():
                #if (name.endswith('jpg') or name.endswith('hdr') or name.endswith('exr') or name.endswith('jpeg') or name.endswith('png')) and name in selected_files:
                    files.append(os.path.basename(name))
            else:
                if extension in image_filters and SEARCH.lower() in name.lower():
                #if name.endswith('jpg') or name.endswith('hdr') or name.endswith('exr') or name.endswith('jpeg') or name.endswith('png'):
                    files.append(os.path.basename(name))
        for f in files:
            hdri_path=os.path.join(i,f)
            if bpy.data.worlds.get(shader_type) is None:
                path = os.path.join(os.path.dirname(os.path.abspath(
                    __file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend", "World")
                init_worlds=bpy.data.worlds[:]
                bpy.ops.wm.append(
                    directory=path,
                    filename=shader_type, autoselect=False
                )
                new_world=[a for a in bpy.data.worlds if a not in init_worlds]
                # print(new_world)
                if new_world:
                    new_world=new_world[0]
                    
                    new_world.name=os.path.splitext(f)[0]
                    node_group=new_world.node_tree.nodes.get(shader_type)
                    node_group.is_ta_node=True
                    for inp,value in SHADER_VALUES.items():
                        try:
                            inp=[a.name for a in node_group.inputs if  a.name.lower().startswith(inp.lower())][0]
                            node_group.inputs[inp].default_value=eval(value)
                        except Exception as e:
                            print(inp,value,e)
                    set_toggles(node_group)
                    image_node=node_group.node_tree.nodes.get("Environment Texture")
                    image_node.image=bpy.data.images.load(hdri_path)
                    preview_image=image_node.image.copy()
                    #if preview_image.size[0]*preview_image.size[0]>100000000:
                    preview_image.scale(1000,500)
                    preview_image.save_render(os.path.join(WORLDS_DIRECTORY,'Thumbnails',image_node.image.name), scene=None)
                    bpy.data.images.remove(preview_image)
                    created_worlds.append((new_world,os.path.join(WORLDS_DIRECTORY,'Thumbnails',image_node.image.name)))
                    
                    if context.scene.world:
                        new_world.cycles.sampling_method=context.scene.world.cycles.sampling_method
                        new_world.cycles.sample_map_resolution=context.scene.world.cycles.sample_map_resolution
                        new_world.cycles.max_bounces=context.scene.world.cycles.max_bounces
                    new_world.asset_mark()
                    new_world.asset_data.tags.new(new_world.name)
                    if catalog!="00000000-0000-0000-0000-000000000000":
                        if catalog=='Directory':
                            new_world.asset_data.catalog_id=create_new_catalog(WORLDS_DIRECTORY,decode_catalog_name(catalog,hdri_path))
                        else:
                            new_world.asset_data.catalog_id=catalog
        if not subfolders:
            break
    if True and created_worlds:
        for w,h in created_worlds:
            with context.temp_override(id=w):
                bpy.ops.ed.lib_id_load_custom_preview( filepath=h)
            bpy.app.timers.register(functools.partial(create_world_preview,[w,],pack))
    else:
        bpy.ops.wm.quit_blender()
setup_hdris(FOLDER_PATH,SELECTED_FILES,IMAGE_FILTERS,SUBFOLDERS,CATALOG,PACK,SHADER_TYPE)