import os
import warnings
import zipfile
import sys
import socket
import certifi
from pathlib import Path
argv=sys.argv[:]
argv = argv[argv.index("--") + 1:] 
DOWNLOAD_FOLDER=argv[0]
ASSET_URL=argv[1]
ASSET_NAME=argv[2]
ASSET_TYPE=argv[3]
BLENDER_VERSION=argv[4]
ADDONS_DIR=Path(__file__).parent.parent
progress_file_path=os.path.join(ADDONS_DIR,"download_progress.txt")

from requests import Session
headers = {'User-Agent': f'TrueAssets/4.1 Blender/{BLENDER_VERSION}'}
s = Session()
s.headers.update(headers)

def isConnected():
    try:
        socket.create_connection(("www.bing.com", 80), timeout=2)
        return True
    except :
        pass
    try:
        response = s.get("http://www.bing.com", timeout=5)
        return True
    except :
        return False
def download_hdri():
    #print(name)
    CANCELLED=False
    with warnings.catch_warnings():
        warnings.simplefilter("ignore")
        if isConnected():
            if ASSET_URL:
                if not os.path.isdir(DOWNLOAD_FOLDER):
                    os.mkdir(DOWNLOAD_FOLDER)
                f = open(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}",'wb')
                try:
                    response=s.get(ASSET_URL,stream=True,verify=False,timeout=10)
                except:
                    response=s.get(ASSET_URL,stream=True,verify=certifi.where(),timeout=10)
                try:
                    if response.status_code == 200:
                        size=eval(response.headers['Content-length'])/1024/1024
                        #print(size/(1024*1024)," MB")
                        i=0
                        for chunk in response.iter_content(chunk_size = 1024*512 ):
                            f.write(chunk)
                            i=i+1
                            try:
                                with open(os.path.join(ADDONS_DIR,"cancel.txt"), "r") as cancel_file:
                                    if cancel_file.read()=='CANCEL':
                                        f.close()
                                        CANCELLED=True
                                        if True and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}"):
                                            os.remove(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}")
                                        progress_file = open(progress_file_path, "w+")
                                        progress_file.write(f"")
                                        progress_file.close()
                                        exit()
                                        break
                            except:
                                pass
                            progress = f"Status: {format(round((i*512/1024),2),'0.2f')}/{format(round(size,2),'0.2f')} MB"
                            progress=f"{format(round((i*512/1024),2),'0.2f')}/{format(round(size,2),'0.2f')}"
                            progress_file = open(progress_file_path, "w+")
                            progress_file.write(f"{progress}")
                            progress_file.close()
                            
                        f.close()
                        if not CANCELLED and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}"):
                            return f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}"
                except Exception as e:
                    print("Download Error!",e)
                    try:
                        f.close()
                        if True and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}"):
                                                os.remove(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}")
                    except Exception:
                        pass
                    
                    progress_file = open(progress_file_path, "w+")
                    progress_file.write(f"Download Failed!")
                    progress_file.close()
                    exit()
        else:
            print("Not Connected!")
    return None
def download_material():
    #print(name)
    CANCELLED=False
    with warnings.catch_warnings():
        warnings.simplefilter("ignore")
        if isConnected():
            if ASSET_URL:
                if not os.path.isdir(DOWNLOAD_FOLDER):
                    os.mkdir(DOWNLOAD_FOLDER)
                f = open(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.{ASSET_TYPE}",'wb')
                try:
                    response=s.get(ASSET_URL,stream=True,verify=False,timeout=10)
                except:
                    response=s.get(ASSET_URL,stream=True,verify=certifi.where(),timeout=10)
                try:
                    if response.status_code == 200:
                        size=eval(response.headers['Content-length'])/1024/1024
                        #print(size/(1024*1024)," MB")
                        i=0
                        for chunk in response.iter_content(chunk_size = 1024*512 ):
                            f.write(chunk)
                            i=i+1
                            try:
                                with open(os.path.join(ADDONS_DIR,"cancel.txt"), "r") as cancel_file:
                                    if cancel_file.read()=='CANCEL':
                                        f.close()
                                        CANCELLED=True
                                        if True and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip"):
                                            os.remove(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip")
                                        progress_file = open(progress_file_path, "w+")
                                        progress_file.write(f"")
                                        progress_file.close()
                                        exit()
                                        break
                            except:
                                pass
                            progress = f"Status: {format(round((i*512/1024),2),'0.2f')}/{format(round(size,2),'0.2f')} MB"
                            progress=f"{format(round((i*512/1024),2),'0.2f')}/{format(round(size,2),'0.2f')}"
                            progress_file = open(progress_file_path, "w+")
                            progress_file.write(f"{progress}")
                            progress_file.close()
                            
                        f.close()
                        if not CANCELLED and ASSET_TYPE=='zip' and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip"):
                            with zipfile.ZipFile(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip", 'r') as zip_ref:
                                for file_info in zip_ref.infolist():
                                    if file_info.is_dir():
                                        folder_name = os.path.dirname(file_info.filename)
                                        if folder_name == ASSET_NAME:
                                            zip_ref.extractall(f"{DOWNLOAD_FOLDER}")
                                            break  # Stop iteration after extracting the desired folder
                                else:
                                    zip_ref.extractall(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}")
                            os.remove(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip")
                            return f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}"
                except Exception as e:
                    print("Download Error!",e)
                    try:
                        f.close()
                        if True and os.path.exists(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip"):
                                                os.remove(f"{os.path.join(DOWNLOAD_FOLDER,ASSET_NAME)}.zip")
                    except Exception:
                        pass
                    progress_file = open(progress_file_path, "w+")
                    progress_file.write(f"Download Failed!")
                    progress_file.close()
                    exit()
        else:
            print("Not Connected!")
    return None
if ASSET_TYPE=='zip':
    download_material()
else:
     download_hdri()