import bpy
import sys
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
FILEPATHS= argv[0].split(":--separator--:")
ALL_NAMES=argv[1].split(":--separator--:")
ALL_TYPES=argv[2].split(":--separator--:")
SHADING=argv[3]
OBJECTS_PATH=argv[4]
CAMERA_ANGLE=argv[5]
ADD_PLANE=eval(argv[6])
WORLD_STRENGTH=eval(argv[7])
FILEPATH=FILEPATHS.pop(0)
TYPES=ALL_TYPES.pop(0).split(":--separator2--:")
NAMES=ALL_NAMES.pop(0).split(":--separator2--:")
RENDER_DEVICE=argv[8]
import os
import mathutils
import random
import functools
context = bpy.context
scene = context.scene
bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
def enable_gpus(device_type, use_cpus=False):
    preferences = bpy.context.preferences
    cycles_preferences = preferences.addons["cycles"].preferences
    devices=cycles_preferences.get_devices_for_type(device_type)
    

    activated_gpus = []

    for device in devices:
        if device.type == "CPU":
            device.use = use_cpus
        else:
            device.use = True
            activated_gpus.append(device.name)

    cycles_preferences.compute_device_type = device_type

    return activated_gpus
try:
    enable_gpus(RENDER_DEVICE)
except Exception as e:
    print(e)
random_id_source = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
def get_id(length=6):
    return "".join(random.sample(random_id_source, length))
supports_thumbnails=['MESH','LIGHT']
def does_support_thumbnails(ob):
    return isinstance(ob,bpy.types.Material) or isinstance(ob,bpy.types.World) or  (isinstance(ob,bpy.types.Object) and ob.type in supports_thumbnails and not (isinstance(ob,bpy.types.Object) and ob.type=='MESH' and len(ob.evaluated_get(bpy.context.evaluated_depsgraph_get()).data.polygons)<1)) or (isinstance(ob,bpy.types.NodeTree) and [a for a in ob.interface.items_tree if a.in_out=='OUTPUT']) or SHADING!='Solid'
def delete_object_with_data(obj):
    if obj and obj.name in bpy.data.objects:
        data = obj.data
        isMesh = obj.type == 'MESH'
        bpy.data.objects.remove(obj, do_unlink=True)
        if isMesh:
            bpy.data.meshes.remove(data)
def get_bounding_box_of_collection(col):
    corners=[]
    for ob in col.all_objects:
        corners.extend([(ob.matrix_world @ mathutils.Vector(b)) for b in ob.bound_box])
    min_z=min(((mathutils.Vector(b)).z for b in corners))
    max_z=max(((mathutils.Vector(b)).z for b in corners))
    min_x=min(((mathutils.Vector(b)).x for b in corners))
    max_x=max(((mathutils.Vector(b)).x for b in corners))
    min_y=min(((mathutils.Vector(b)).y for b in corners))
    max_y=max(((mathutils.Vector(b)).y for b in corners))
    return mathutils.Vector((min_x,min_y,min_z)),mathutils.Vector((max_x,max_y,max_z))
def get_collections_from_scene(scene):
    return [c for c in bpy.data.collections if scene.user_of_id(c)]
def capture_thumbnail_for_collection(context,col,path, shading="Material",angle='X',add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene=context.scene
    scene.render.image_settings.file_format = 'PNG'  
    file_format=scene.render.image_settings.file_format
    if col not in get_collections_from_scene(scene):
        scene.collection.children.link(col)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(col.name+"_"+get_id(8))+'.png')
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_data.clip_start=0
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    bottom_left,top_right=get_bounding_box_of_collection(col)
    local_bbox_center =(bottom_left+top_right)/2
    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        scene.collection.objects.link(ground_plane)
        min_z=bottom_left.z
        ground_plane.location=(local_bbox_center.x, local_bbox_center.y,min_z)
    global_bbox_center = local_bbox_center
    track_object.location=global_bbox_center
    dist=max([abs(top_right.x-bottom_left.x),abs(top_right.y-bottom_left.y),abs(top_right.z-bottom_left.z)])*2
    #object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
    camera_object.location=mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    
    
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    # override = context.copy()
    # override["object"] = camera_object
    with context.temp_override(object=camera_object):
        bpy.ops.constraint.apply(constraint=constraint.name)
    
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    create_3dview=False
    if not [area for area in context.window_manager.windows[0].screen.areas if area.type=='VIEW_3D']:
        create_3dview=True
    for area in context.window_manager.windows[0].screen.areas:
        if not create_3dview:
            if area.type=='VIEW_3D':
                
                #override['scene']=scene
                override['area']=area
                override['space_data']=area.spaces[0]
                override['screen']=context.window_manager.windows[0].screen
                override['window']=context.window_manager.windows[0]
                area.spaces[0].region_3d.view_perspective = 'CAMERA'
                override['active']=col.all_objects[0] if col.all_objects else None
                if col.all_objects:
                    override['selected_objects']=[col.all_objects[0],]
                view_area=area
                break
        else:
            #override['scene']=scene
                area.type='VIEW_3D'
                override['area']=area
                override['space_data']=area.spaces[0]
                override['screen']=context.window_manager.windows[0].screen
                override['window']=context.window_manager.windows[0]
                area.spaces[0].region_3d.view_perspective = 'CAMERA'
                override['active']=col.all_objects[0] if col.all_objects else None
                if col.all_objects:
                    override['selected_objects']=[col.all_objects[0],]
                view_area=area
                break          
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    backup_world=context.scene.world
    context.scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=context.scene.world.node_tree.nodes.get("Mapping")
    context.scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]          
    if shading=='Material':
        
        view_area.spaces[0].shading.type = 'MATERIAL'
        view_area.spaces[0].overlay.show_overlays = False
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_viewport == False:
                obj.hide_viewport = True
                hidden.append(obj)
        with context.temp_override(**override):
            bpy.ops.render.opengl(write_still=True)
        for obj in hidden:
            obj.hide_viewport = False
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected=[a for a in scene.objects if a.name not in col.all_objects]
        for obj in unselected:
            if obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
        
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    scene.world=backup_world
    if bpy.data.worlds.get("TA_Thumbnail_World"):
        if bpy.data.worlds.get("TA_Thumbnail_World").node_tree.nodes.get("Environment Texture").image:
            bpy.data.images.remove(bpy.data.worlds.get("TA_Thumbnail_World").node_tree.nodes.get("Environment Texture").image)
        bpy.data.worlds.remove(bpy.data.worlds.get("TA_Thumbnail_World"))
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    scene.camera = cameraBackUp
    scene.render.image_settings.file_format = file_format
    #context.window.scene=scene_backup
    if ground_plane:
        delete_object_with_data(ground_plane)
    return render_path
def capture_thumbnail(context,object,path, shading="Material",add_plane=True):
    #print(object)
    hidden = []
    # if object not in context.window_manager.windows[0].scene.objects[:]:
    #     context.window_manager.windows[0].scene=find_scene_from_object(object) if find_scene_from_object(object) else context.window_manager.windows[0].scene
    #     print("New Scene",context.window_manager.windows[0].scene)
    
    scene_backup=context.scene
    scene=context.scene  
    scene.render.image_settings.file_format = 'PNG'
    file_format=scene.render.image_settings.file_format
    scene.render.image_settings.file_format = 'PNG'
    if object not in scene.objects[:]:
        scene.collection.objects.link(object)
    view_area=None  
    filepath=scene.render.filepath

    render_path=os.path.join(path,bpy.path.clean_name(object.name+"_"+get_id(8))+'.png')
    scene.render.filepath=render_path
    cameraBackUp = scene.camera
    camera_data = bpy.data.cameras.new(name='Camera')
    camera_data.clip_end=10000000
    camera_data.clip_start=0
    camera_object = bpy.data.objects.new('Camera', camera_data)
    scene.collection.objects.link(camera_object)
    track_object=bpy.data.objects.new("Track",object_data=None)
    scene.collection.objects.link(track_object)
    local_bbox_center = 0.125 * sum((mathutils.Vector(b) for b in object.bound_box), mathutils.Vector())
    ground_plane=None
    if add_plane:
        mesh_data = bpy.data.meshes.new("TA_Plane")
        polycoords=[(1000,1000,0),(1000,-1000,0),(-1000,-1000,0),(-1000,1000,0)]
        polyIndices = [(i, (i+1) % (len(polycoords)))
                        for i in range(0, len(polycoords))]
        mesh_data.from_pydata(polycoords, polyIndices, [
                                [i for i in range(0, len(polycoords))]])
        mesh_data.validate()
        ground_plane = bpy.data.objects.new("TA_Plane", mesh_data)
        subsurf_mod=ground_plane.modifiers.new(type='SUBSURF',name="TA_SUBSURF")
        subsurf_mod.levels=4
        subsurf_mod.render_levels=4
        subsurf_mod.subdivision_type='SIMPLE'
        context.scene.collection.objects.link(ground_plane)
        min_z=min(((object.matrix_world @ mathutils.Vector(b)).z for b in object.bound_box))
        ground_plane.location=(object.location.x, object.location.y,min_z)
    global_bbox_center = object.matrix_world @ local_bbox_center
    track_object.location=global_bbox_center
    dist=max(object.dimensions[:])*2
    object_matrix=mathutils.Matrix.LocRotScale(track_object.location, object.rotation_quaternion,[1,1,1])
    camera_object.location=object_matrix@mathutils.Vector((-dist if '-X' in CAMERA_ANGLE else (dist if 'X' in CAMERA_ANGLE else 0),dist if '-Y' in CAMERA_ANGLE else (-dist if 'Y' in CAMERA_ANGLE else 0),dist*(-1 if '-Z' in CAMERA_ANGLE  else 1) ))
    constraint=camera_object.constraints.new('TRACK_TO')
    constraint.name="TA_Track_To"
    constraint.target=track_object
    constraint.up_axis='UP_Y'
    # override = context.copy()
    # override["object"] = camera_object
    with context.temp_override(object=camera_object):
        bpy.ops.constraint.apply(constraint=constraint.name)
    bpy.data.objects.remove(track_object)
    scene.camera = camera_object
    camera_data.lens = 80
    transparent_backup=scene.render.film_transparent
    scene.render.film_transparent=True
    rendexXbackUp = scene.render.resolution_x
    rendexYbackUp = scene.render.resolution_y
    scene.render.resolution_x = 256
    scene.render.resolution_y = 256
    scene.use_nodes=False
    override=context.copy()
    create_3dview=False
    if not [area for area in context.window_manager.windows[0].screen.areas if area.type=='VIEW_3D']:
        create_3dview=True
    for area in context.window_manager.windows[0].screen.areas:
        if not create_3dview:
            if area.type=='VIEW_3D':
                
                #override['scene']=scene
                override['area']=area
                override['space_data']=area.spaces[0]
                override['screen']=context.window_manager.windows[0].screen
                override['window']=context.window_manager.windows[0]
                area.spaces[0].region_3d.view_perspective = 'CAMERA'
                override['active']=object
                override['selected_objects']=[object,]
                view_area=area
                break
        else:
            #override['scene']=scene
                area.type='VIEW_3D'
                override['area']=area
                override['space_data']=area.spaces[0]
                override['screen']=context.window_manager.windows[0].screen
                override['window']=context.window_manager.windows[0]
                area.spaces[0].region_3d.view_perspective = 'CAMERA'
                override['active']=object
                override['selected_objects']=[object,]
                view_area=area
                break          
    if not bpy.data.worlds.get("TA_Thumbnail_World"):
        asset_file=os.path.join(os.path.dirname(
                    os.path.abspath(__file__)), "Assets", "Assets.blend" if bpy.app.version>=(3,4,0) else "Assets_Old.blend","World")
        with context.temp_override(**override):
            bpy.ops.wm.append(
                directory=asset_file,
                filename="TA_Thumbnail_World", autoselect=False
            )
    backup_world=context.scene.world
    scene.world=bpy.data.worlds.get("TA_Thumbnail_World")        
    map_node=scene.world.node_tree.nodes.get("Mapping")
    scene.world.node_tree.nodes.get("Background").inputs[1].default_value=WORLD_STRENGTH
    if map_node:
        map_node.inputs[2].default_value=[map_node.inputs[2].default_value[0],map_node.inputs[2].default_value[1],0.785398-camera_object.rotation_euler.z]
    if shading=='Material':
        
        view_area.spaces[0].shading.type = 'MATERIAL'
        view_area.spaces[0].overlay.show_overlays = False
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.hide_get() == False:
                obj.hide_set(True)
                hidden.append(obj)
        og_hide_render=object.hide_render
        object.hide_render=False
        bpy.ops.render.render(write_still=True)
        object.hide_render=og_hide_render
        for obj in hidden:
            obj.hide_set(False)
    elif shading=='Eevee':
        engine = scene.render.engine
        scene.render.engine = 'BLENDER_EEVEE'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    else:
        samples=context.scene.cycles.samples
        context.scene.cycles.samples=64
        engine = scene.render.engine
        scene.render.engine = 'CYCLES'
        unselected = [a for a in scene.objects if a !=object and a!=ground_plane]
        for obj in unselected:
            if obj.type != "LIGHT" and obj.hide_render == False:
                obj.hide_render = True
                hidden.append(obj)
        bpy.ops.render.render(write_still=True)
        context.scene.cycles.samples=samples
        scene.render.engine = engine
        for obj in hidden:
            obj.hide_render = False
    scene.render.resolution_x = rendexXbackUp
    scene.render.resolution_y = rendexYbackUp
    scene.render.film_transparent=transparent_backup
    scene.render.filepath=filepath
    scene.world=backup_world
    if bpy.data.worlds.get("TA_Thumbnail_World"):
        if bpy.data.worlds.get("TA_Thumbnail_World").node_tree.nodes.get("Environment Texture").image:
            bpy.data.images.remove(bpy.data.worlds.get("TA_Thumbnail_World").node_tree.nodes.get("Environment Texture").image)
        bpy.data.worlds.remove(bpy.data.worlds.get("TA_Thumbnail_World"))
    if camera_object:
           bpy.data.objects.remove(camera_object, do_unlink=True)
    scene.camera = cameraBackUp
    scene.render.image_settings.file_format = file_format
    #context.window.scene=scene_backup
    if ground_plane:
        delete_object_with_data(ground_plane)
    return render_path
def create_thumbnail(context, ob,shading='Solid'):
    if not os.path.isdir(os.path.join(OBJECTS_PATH,'Thumbnails')):
        os.mkdir(os.path.join(OBJECTS_PATH,'Thumbnails'))
    if shading!='Solid':
        if isinstance(ob,bpy.types.Collection):
            path=capture_thumbnail_for_collection(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
        else:
            path=capture_thumbnail(context,ob,os.path.join(OBJECTS_PATH,'Thumbnails'),shading,add_plane=ADD_PLANE)
        #print(path)
        if os.path.isfile(path):
            with context.temp_override(id=ob):
                bpy.ops.ed.lib_id_load_custom_preview( filepath=path)
    else:
        ob.asset_generate_preview()
def check_if_volumetric(mat):
    if mat.use_nodes:
        output_nodes=[node for node in mat.node_tree.nodes if node.bl_idname=='ShaderNodeOutputMaterial']
        for node in output_nodes:
            if node.inputs[1].is_linked:
                return True
def create_preview(objects):
    global FILEPATHS,FILEPATH,ALL_NAMES,ALL_TYPES,NAMES,TYPES
    obs=objects[:]
    while obs:
        ob=obs[0]
        if not ob.preview or any(ob.preview.image_pixels[:]) or SHADING!="Solid" or (type=='MATS' and check_if_volumetric(ob)):
            obs.pop(0)
        else:
            return 1
    bpy.ops.wm.save_mainfile()
    bk = FILEPATH + "1"
    if os.path.exists(bk):
        os.remove(bk)
    if FILEPATHS and ALL_NAMES and ALL_TYPES:
        FILEPATH=FILEPATHS.pop(0)
        NAMES=ALL_NAMES.pop(0).split(":--separator--:")
        TYPES=ALL_TYPES.pop(0).split(":--separator--:")
        bpy.ops.wm.open_mainfile(filepath=FILEPATH,load_ui =False)
        start_regenerating()
    else:
        bpy.ops.wm.quit_blender()
    return None
def start_regenerating():
    print(TYPES,NAMES)
    try:
        objects=[]
        for i,a in enumerate(TYPES):
            
            if a=='COLLECTION':
                ob=bpy.data.collections.get(NAMES[i])
                if ob:
                    objects.append(ob)
                    create_thumbnail(bpy.context,ob,SHADING)
            elif a=='MATERIAL':
                ob=bpy.data.materials.get(NAMES[i])
                objects.append(ob)
                if ob:
                    ob.asset_generate_preview()
                
            else:
                ob=bpy.data.objects.get(NAMES[i])
                if ob:
                    if ob.type in {'MESH','CURVE','SURFACE','TEXT','META'}:
                        ob.display_type='TEXTURED'
                    if does_support_thumbnails(ob):
                        objects.append(ob)
                        create_thumbnail(bpy.context,ob,SHADING)
        bpy.app.timers.register(functools.partial(
    create_preview, objects), first_interval=0)
    except Exception as e:
        print(e,"An Error Occured!")

start_regenerating()