import os
import warnings
import socket
import time
from requests import Session
import multiprocessing.dummy as multiprocessing
import certifi
import requests
import bpy
import uuid
import re
import sys
argv = sys.argv
argv = argv[argv.index("--") + 1:] 
AMBIENTCG_DIR_PATH=argv[0]
DOWNLOAD_DIR_PATH=argv[1]
bpy.types.Material.ta_asset_id=bpy.props.StringProperty(name="",default="")
bpy.types.Material.ta_tags=bpy.props.StringProperty(name="Tags",default="")
bpy.types.Material.ta_qualities=bpy.props.StringProperty(name="Qualities",default="")
bpy.types.Material.st_slug=bpy.props.StringProperty(name="URL",default="")
bpy.types.Material.is_ta_dummy_mat=bpy.props.BoolProperty(name="Is Ta Dummy",default=False)
bpy.types.World.ta_asset_id=bpy.props.StringProperty(name="",default="")
bpy.types.World.ta_tags=bpy.props.StringProperty(name="Tags",default="")
bpy.types.World.ta_qualities=bpy.props.StringProperty(name="Qualities",default="")
bpy.types.World.is_ta_dummy_world=bpy.props.BoolProperty(name="Is Ta Dummy",default=False)
previewSize=256
__DIRNAME__ = os.path.dirname(os.path.dirname(__file__))

headers = {'User-Agent': f'TrueAssets/4.1 Blender/{bpy.app.version_string}'}
# headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Safari/537.36'}
# headers = {'User-Agent':random_user_agent}
s = Session()
s.headers.update(headers)
def check_if_downloaded(name,quality):
    if name in os.listdir(DOWNLOAD_DIR_PATH):
        if quality+".blend" in os.listdir(os.path.join(DOWNLOAD_DIR_PATH,name)):
            return True
    return False
def isConnected():
    try:
        socket.create_connection(("www.bing.com", 80), timeout=2)
        return True
    except :
        pass
    try:
        response = s.get("http://www.bing.com", timeout=5)
        return True
    except :
        return False
    
previews_downloaded=0
def savePreviewPar(asset):
    path, url,qualities,_,_,_ = asset
    #url=url.replace("https",'http')
    # print(url)
    try:
        with warnings.catch_warnings():
            warnings.simplefilter("ignore")
            if not os.path.isfile(path):
                with open(path, 'wb') as file:
                    try:
                        file.write(requests.get(url,verify=False).content)
                        
                    except:
                        file.write(requests.get(url,verify=certifi.where()).content)
        global previews_downloaded
        previews_downloaded+=1
        progress=round(previews_downloaded/len(previews_to_download),2)
        progress_file = open(os.path.join(os.path.dirname(os.path.dirname(__file__)),"progress.txt"), "w",newline='\n',encoding='utf-8')
        progress_file.writelines(["Downloading Previews...\n",f"{progress}"])
        progress_file.close()
    except Exception as e:
        print(e)

def fetch_assets(existing_assets=[]):
    progress_file = open(os.path.join(os.path.dirname(os.path.dirname(__file__)),"progress.txt"), "w",encoding='utf-8')
    progress_file.writelines(["Fetching ShareTextures Materials...\n"])
    progress_file.close()
    if not os.path.isdir(os.path.join(__DIRNAME__, 'TA-Previews')):
                os.mkdir(os.path.join(__DIRNAME__, 'TA-Previews'))
    finished=False
    
    with warnings.catch_warnings():
        warnings.simplefilter("ignore")
        if isConnected():
            try:
                st=time.time()
                try:
                    response = s.get("http://api2.sharetextures.com/api/v0/for-frontend/items", params = {'itemType':'textures','page':500}, timeout=20,verify=certifi.where())
                except:
                    return "ERROR",[],True
                if response.status_code!=200:
                    print(f"ERROR: Response status code {response.status_code}")
                    return "ERROR",[],True
                # print(json_data['foundAssets'])
                if response.status_code==200:
                    json_data = response.json()
                    total_assets=json_data['data']['pagination']['totalCount']
                    assets = [
                        (
                    os.path.join(__DIRNAME__, 'TA-Previews', asset['title']+".png"),
                    "https://images.sharetextures.com/"+asset['previewImage1']['thumbObjectKey'],
                    [asset['title'],] ,
                    asset['category']['name'],
                    [a['text'] for a in asset['tags']],f"https://www.sharetextures.com/_next/data/1cxHSsmDt99I6ASNiFd2s/textures/{asset['category']['slug']}/{asset['slug']}.json"
                )
                        for asset in json_data['data']['items']
                    ]
                    finished=True
                    new_assets=[a for a in assets if a[2][0] not in existing_assets]
                    all_assets=[a[2][0] for a in assets]
                    
                    return new_assets,all_assets,finished
            except Exception as e:
                print("Error",e)
                #self.report({'WARNING'},"Couldn't Connect")
        else:
            print("Couldn't Connect")
#        self.report({'WARNING'},"Couldn't Connect")
    return [],[],finished
def is_zip_asset(asset):
    try:
        return "zip" in list(asset['downloadFolders']['default']['downloadFiletypeCategories'].keys())
    except Exception as e:
        return False

def write_to_blend(objects):
    blend_name="ShareTextures.blend"
    if objects:
        path=os.path.join(AMBIENTCG_DIR_PATH,blend_name)
        bpy.data.libraries.write(path
                        , set(objects), fake_user=True)
def get_random_uuid():
    return str(uuid.uuid4())
def get_catalog_by_name(path,name):
    if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='r',newline="\n",encoding="UTF-8") as catalog_file:
            for l in catalog_file.readlines():
                if not l.startswith("#") and not l.startswith("VERSION") and ":" in l:
                    if l[l.index(":")+1:l.rindex(":")]==name:
                        return l[:l.index(":")]
    return None
def create_new_catalog(path,name):
    uuids=[]
    #uuid=get_random_uuid()
    result = [_.start() for _ in re.finditer("/",name )] +[len(name),]
    for a in range(len(result)):
        uuids.append(get_random_uuid())
    if not os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
        with open(os.path.join(path,"blender_assets.cats.txt"), mode='w+',newline="\n",encoding="UTF-8") as catalog_file:
            catalog_file.writelines(["\nVERSION 1",])
            for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    else:
        
        if os.path.isfile(os.path.join(path,"blender_assets.cats.txt")):
            with open(os.path.join(path,"blender_assets.cats.txt"), mode='a',newline="\n",encoding="UTF-8") as catalog_file:
                for index,i in enumerate(result):
                    if not get_catalog_by_name(path,name[:i]):
                        catalog_file.writelines(["\n"+uuids[index]+f":{name[:i]}:{name[:i]}\n",])
    
    return get_catalog_by_name(path,name) if get_catalog_by_name(path,name) else "00000000-0000-0000-0000-000000000000"
finished=False
count=0
mats=[]
existing_assets=[]
try:
    # print(os.path.isfile(os.path.join(AMBIENTCG_DIR_PATH,'ShareTextures.blend')))
    with bpy.data.libraries.load(os.path.join(AMBIENTCG_DIR_PATH,'ShareTextures.blend')) as (data_from, data_to):
        for mat in data_from.materials:
            data_to.materials.append(mat)
            existing_assets.append(mat)
        for world in data_from.worlds:
            data_to.worlds.append(world)
            existing_assets.append(world)
except Exception as e:
    print("No Existing Assets!")
# print(existing_assets,len(existing_assets))

ERROR_COUNT=0
# print(len(hdri_assets))
finished=False
count=0
new_material_assets=[]
material_assets_online=[]
while(not finished):
    st=time.time()
    # print("Starting Fetch Materials")
    assets,all_assets,finished=fetch_assets(existing_assets)
    # print("material fetch")
    # print(time.time()-st)
    if assets=='ERROR' and count<25:
        ERROR_COUNT+=1
        finished=False
        time.sleep(ERROR_COUNT*2)
    else:
        material_assets_online.extend(all_assets)
        new_material_assets.extend(assets)
    count+=1
    if count>25 or ERROR_COUNT>4:
        break
    
# print(len(material_assets))
previews_to_download=[asset for asset in new_material_assets if not os.path.isfile(asset[0])]
if len(previews_to_download)>6:
    with multiprocessing.Pool() as pool:
        pool.map(savePreviewPar, previews_to_download, chunksize = 2)
else:
    for ase in previews_to_download:
        
        savePreviewPar(ase)
print(f"{len(new_material_assets)} New Assets!")
try:
    progress_file = open(os.path.join(os.path.dirname(os.path.dirname(__file__)),"progress.txt"), "w+",encoding='utf-8')
    progress_file.writelines(["Creating Assets...\n",0])
    progress_file.close()
except Exception:
    pass

for asset in new_material_assets:
    mat=bpy.data.materials.new(name=asset[2][0])
    mat.use_fake_user=True
    mats.append(mat)
    mat.asset_mark()
    if os.path.isfile(asset[0]):
        with bpy.context.temp_override(id=mat):
            bpy.ops.ed.lib_id_load_custom_preview(filepath=asset[0])
    mat.ta_tags=",".join(asset[4])
    mat.ta_qualities=",".join(('1K','2K','4K'))
    mat.ta_asset_id=asset[2][0]
    mat.is_ta_dummy_mat=True
    mat.st_slug=asset[5]
    
    mat.asset_data.catalog_id=create_new_catalog(AMBIENTCG_DIR_PATH,f"Materials/Sharetextures/{asset[3]}")
    mat.asset_data.author='ShareTextures'
    for tag in asset[2]:
        mat.asset_data.tags.new(tag)
    for tag in ['1K-PNG()','2K-PNG()','4K-PNG()']:
        mat.asset_data.tags.new(tag)

for a in bpy.data.materials[:]+bpy.data.worlds[:]:
    if a.asset_data:
        for tag in a.asset_data.tags:
            if "Downloaded" in tag.name:
                a.asset_data.tags.remove(tag)
for a in bpy.data.materials[:]+bpy.data.worlds[:]:
    if a.asset_data:
        for q in getattr(a,'ta_qualities',"None").split(","):
            if "(" in q:
                quality=q[:q.index('(')]
                if check_if_downloaded(a.name,quality):
                    a.asset_data.tags.new(f"Downloaded-{quality}")
print(f"{len(bpy.data.materials[:]+bpy.data.worlds[:])} Total Assets")
write_to_blend([a for a in bpy.data.materials if not material_assets_online or a.name in material_assets_online])
progress_file = open(os.path.join(os.path.dirname(os.path.dirname(__file__)),"progress.txt"), "w",encoding='utf-8')
progress_file.writelines(["\n",f"{0}"])
progress_file.close()
bpy.ops.wm.quit_blender()